<?
//////////////////////////////////////////////////////////////////////
////
////  MAHC - MAHC Advanced Html Chat Version 1.0.0
////  Complex Chat System Written in PHP4 Supporting HTML-only clients
////  Copyright (C) 2001 Joseph Durbin <jdurbin@users.sourceforge.net>
////  This Source is GNU GPL, See file LICENSE in distribution.
////
//////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////
/////// ai.php  ELIZA-style  AI Test Processor
//////  MAHC Component
//////  September 2001 - Joe Durbin
///////////////////////////////////////////////////////////////////////

		
//// ELIZA Style Database
/////////////// Conjunction Transformations
$reversals=array(                     
    array("are","am"),
    array("am","are"),
    array("were","was"),
    array("was","were"),
    array("i","you"),    
    array("me","you"),    
    array("you","me"),
    array("my","your"),    
    array("your","my"),
    array("mine","your's"),    
    array("your\'s","mine"),    
    array("i\'m","you\'re"),
    array("you\'re","I\'m"),    
    array("i\'ve","you\'ve"),
    array("you\'ve","I\'ve"),
    array("i\'ll","you\'ll"),
    array("you\'ll","I\'ll"),
    array("myself","yourself"),
    array("yourself","myself"),
);
//////////////// Pronoun Corrections
$corrections=array(    
    array(" me am"," I am"),
    array(" am me"," am I"),
    array(" me can"," I can"),
    array(" can me"," can I"),
    array(" me have"," I have"),
    array(" me will"," I will"),
    array(" will me"," will I"),
    array(" if me"," if I"),
    array(" could me"," could I"),
    array(" would me"," would I"),
    array(" me could"," I could"),
    array(" me would"," I would"),



);  
//////////////// Keywords Understood and canned responses

$data=  ///  $data[record number][0=keywords;1=responses][string number]
array(
  array (
    array( "NO KEY FOUND"),
    array("Say, do you have any psychological problems?",
          "What does that suggest to you?",
          "I see.",
          "I'm not sure I understand you fully.",
          "Come, come, elucidate your thoughts.",
          "Can you elaborate on that?",
          "That is quite interesting.",
  )),
  array (
    array( "NO KEY REALLY SHORT"),
    array("You have to talk to me if you want my help, please go on..",
          "*>!?",
          ":-)",
          ":-(",
          "Please,  say something more than \"*>\"..  I need details to fully understand you!",
          "Can you elaborate on that?",
  )),
  array (
    array( "REPEAT INPUT"),
    array("Why did you repeat yourself?",
          "Do you expect a different answer by repeating yourself?",
          "Come, come, elucidate your thoughts.",
          "Please don't repeat yourself!",
          "I heard you the first time you said \"*>\".",
  )),
  array (
    array("CAN YOU"),
    array("Don't you believe that I can *>?",
          "Perhaps you would like to be able to *>.",
          "You want me to be able to *>?",
  )),
  array (
    array("CAN I"),
    array("Perhaps you don't want to *>.",
          "Do you want to be able to *>?",
  )),
  array (
    array("YOU ARE","YOU\'RE","YOURE"),
    array("What makes you think I am *>?",
          "Does it please you to believe I am *>?",
          "Perhaps you would like to be *>.",
          "Do you sometimes wish you were *>?",
  )),
  array (
    array("MAYBE"),
    array("You don't seem quite certain.",
          "Why the uncertain tone?",
          "Can't you be more positive?",
          "You aren't sure?",
          "Don't you know?",
  )),
  array (
    array("I DON\'T","I DONT"),
    array("Don't you really *>?",
          "Why don't you *>?",
          "Do you wish to be able to *>?",
          "Does that trouble you?",
  )),
  array (
    array("I FEEL"),
    array("Tell me more about such feelings.",
          "Do you often feel *>?",
          "Do you enjoy feeling *>?",
  )),
  array (
    array("HELLO","HI"),
    array("How are you today.. What would you like to discuss?",
  )),
  array (
    array("WHY DON\'T YOU","WHY DONT YOU"),
    array("Do you really believe I don't *>?",
          "Perhaps in good time I will *>.",
          "Do you want me to *>?",
  )),
  array (
    array( "WHY CAN\'T I","WHY CANT I"),
    array("Do you think you should be able to *>?",
          "Why can't you *>?",
  )),
  array (
    array( "ARE YOU"),
    array("Why are you interested in whether or not I am *>?",
          "Would you prefer if I were not *>?",
          "Perhaps in your fantasies I am *>.",
  )),
  array (
    array( "I CAN\'T","I CANT"),
    array("How do you know you can't *>?",
          "Have you tried?",
          "Perhaps you can now *>.",
  )),
  array (
    array( "I AM","I\'M","IM"),
    array("Did you come to me because you are *>?",
          "How long have you been *>",
          "Do you believe it is normal to be *>?",
          "Do you enjoy being *>?",
  )),
  array (
    array( "YOU"),
    array("We were discussing you, not me.",
          "Oh... *>.",
          "You're not really talking about me, are you?",
  )),
  array (
    array( "YOUR"),
    array("Why are you concerned about my *>?",
          "What about your own *>?",
  )),
  array (
    array( "I WANT"),
    array("What would it mean to you if you got *>?",
          "Why do you want *>?",
          "Suppose you got *>.",
          "What if you never got *>?",
          "I sometimes also want *>.",
  )),
  array (
    array( "WHAT","HOW","WHO","WHERE","WHEN","WHY"),
    array("Why do you ask?",
          "Does that question interest you?",
          "What answer would please you the most?",
          "What do you think?",
          "Are such questions on your mind often?",
          "What is it that you really want to know?",
          "Have you asked anyone else?",
          "Have you asked such questions before?",
          "What else comes to mind when you ask that?",
  )),
  array (
    array( "NAME"),
    array("Names don't interest me.",
          "I don't care about names, please go on.",
  )),
  array (
    array("CAUSE"),
    array("Is that the real reason?",
          "Don't any other reasons come to mind?",
          "Does that reason explain anything else?",
          "What other reasons might there be?",
  )),
  array (
    array( "SORRY"),
    array("Please don't apologize!",
          "Apologies are not necessary.",
          "What feelings do you have when you apologize?",
          "Don't be so defensive!",
  )),
  array (
    array( "DREAM","DREAMS"),
    array("What does that dream suggest to you?",
          "Do you dream often?",
          "What persons appear in your dreams?",
          "Are you disturbed by your dreams?",
  )),
  array (
    array( "NO","NOPE","NAH"),
    array("Are you saying no just to be negative?",
          "You are being a bit negative.",
          "Why not?",
          "Are you sure?",
          "Why no?",
  )),
  array (
    array( "ALWAYS"),
    array("Can you think of a specific example?",
          "When?",
          "What are you thinking of?",
          "Really, always?",
  )),
  array (
    array( "I THINK"),
    array("Do you really think so?",
          "But you are not sure you *>?",
          "Do you doubt you *>?",
  )),
  array (
    array( "THINKS"),
    array("How does ><* thinking this make you feel?",
          "*>!? ><* must be wrong!",
          "Do you really believe ><* thinks *>?",
  )),
  array (
    array( "ALIKE"),
    array("In what way?",
          "What resemblence do you see?",
          "What does the similarity suggest to you?",
          "What other connections do you see?",
          "Could there really be some connection?",
          "How?",
          "You seem quite positive.",
  )),
  array (
    array( "YES"),
    array("Are you Sure?",
         "I see. Please explain more.",
         "I understand. Please, go on...",
  )),
  array (
    array( "FRIEND"),
    array("Why do you bring up the topic of friends?",
         "Do your friends worry you?",
         "Do your friends pick on you?",
         "Are you sure you have any friends?",
         "Do you impose on your friends?",
         "Perhaps your love for friends worries you.",
  )),
  array (
    array( "COMPUTER"),
    array("Do computers worry you?",
          "Are you talking about me in particular?",
          "Are you frightened by machines?",
          "Why do you mention computers?",
          "What do you think machines have to do with your problems?",
          "Don't you think computers can help people?",
          "What is it about machines that worries you?",
  )),
  array (
    array( "BECAUSE","CAUSE"),
    array("And *> is a good reason?",
          "Are you sure that *> is the reason?",
  )),
  array (
    array( "HATES"),
    array("Why Does ><* hate *><?",
          "What made ><* hate *><?",
          "Who do you think made ><* hate *><?",
  )),
  array (
    array( "HATE"),
    array("What made ><* hate *><?",
          "Who do you think made ><* hate *><?",
          "Why do ><* hate *><?",
  )),
  array (
    array( "LOVES"),
    array("Why Does ><* love *><?",
  )),
  array (
    array( "LOVE"),
    array("When did ><* start loving *><?",
          "How long have ><* loved *><?",
          "Why do ><* love *><?",
  )),
  array (
    array( "ENJOY"),
    array("How long have ><* enjoyed *>?",
          "Why do you think ><* enjoy *>?",
  )),
  array (
    array( "ENJOYS"),
    array("How long has ><* enjoyed *>?",
          "Why do you think ><* enjoys *>?",
  )),
  array (
    array( "LIKE TO","LOVE TO"),
    array("How long have ><* liked to *>?",
          "Why do you think ><* like to *>?",
  )),
  array (
    array( "LIKES TO"),
    array("How long has ><* liked to *>?",
          "Why do you think ><* likes to *>?",
  )),
  array (
    array( "KILL"),
    array("Why do you want to kill *>?",
          "Kill *>!?! This begins to leave the realm of doctor-patient confidentiality.",
  )),
  array (
    array( "KILLED","DEATH","DIED"),
    array("Death is a very serious subject. How has this affected you?",
          "Life is a very short experience... Go on.. ",
  )),
  array (
    array( "WISH"),
    array("And what would your life be like if *>?",
          "How long have you wished *>?",
  )),
  array (
    array( "AFRAID","SCARED"),
    array("Why afraid *>?",
          "How do you think the fear *> could be cured?",
  )),
  array (
    array( "FEAR","FEARS","FEAR OF"),
    array("Fears are a very serious personal pshycological dillema.",
          "How long has *> been a fear?",
          "Do you think that *> is a common fear?",
  )),
  array (
    array( "I KNOW"),
    array("How do you know *>?",
          "Are you sure *>?",
          "I do not believe that you know *>!",
  )),
  array (
    array( "ANGRY AT","MAD AT","PISSED AT","IS ANGRY AT","IS MAD AT","IS PISSED AT",
           "AM ANGRY AT","AM MAD AT","AM PISSED AT","WAS ANGRY AT","WAS MAD AT",
           "WAS PISSED AT","AM SO ANGRY AT","AM SO MAD AT","AM SO PISSED AT"),
    array("How can you be sure ><* is mad at *>?",
          "What reason would ><* have for being mad at *>?",
          "Anger can be a tough emotion to deal with, please tell me more.",
  )),
  array (
    array( "ANGRY","MAD","PISSED","PISSEDOFF"),
    array("Anger can be a tough emotion to deal with, please tell me more.",
          "Does it hurt you to think about the casue of this anger?",
  )),
  array (
    array("DOCTOR"),
    array("Please, just call me Doc.  =)",
  )),
  array (
    array("THANK YOU","THANKYOU","THANKS","THANX"),
    array("Well, you're very welcome.",
          "You're welcome!  Please, go on.",
  )),
  array (
    array("TRUTH"),
    array("The truth?",
          "Are you sure you want to know the truth?",
  )),

);


function AIChat($Message,$LastMessage) {
	// Import database defined above
	global $reversals,$corrections,$data;
	$MESSAGE=strtoupper($Message);  // Change text to uppercase.
	// pad message with spaces in front/back and replace punctuatuon with spaces.
	$PADDEDMESSAGE=" ".str_replace(","," ",str_replace("!"," ",str_replace("?"," ",str_replace("."," ",$MESSAGE))))." ";
	/// Following loop searches for keywords in message. longer keywords are given matching priority
	$numkeywords=count($data);
	$KEYWORD=0; $KEYWORDSTRING=""; $BEST=0;
	for ($i=0; $i<$numkeywords; ++$i) {
	  for ($j=0; $j<count($data[$i][0]); ++$j) {
	    if ((strstr($PADDEDMESSAGE," ".$data[$i][0][$j]." ")!="")&&(strlen($data[$i][0][$j])>=$BEST)) {
	      $BEST=strlen($data[$i][0][$j]);
	      $KEYWORD=$i;
	      $KEYWORDSTRING=$data[$i][0][$j];
	      $Pos=strpos($PADDEDMESSAGE," ".$data[$i][0][$j]." ");
	      $RIGHT=substr($PADDEDMESSAGE,$Pos+2+strlen($data[$i][0][$j]));  // Right is the text after a keyword in a message
	      $LEFT=substr($PADDEDMESSAGE,1,$Pos);  // left side of keyword text
	    }
	  } 
	}
	if ($KEYWORD==0) $RIGHT=$Message;  // if theres no keyword, make the whole text the possible substitution.
	if ($KEYWORD==0) {  // Keyword UnMatched! Replace with "no key found" keyword!
	   if (strlen($Message)<6) {
             for ($i=0; $i<$numkeywords; ++$i) if ($data[$i][0][0]=="NO KEY REALLY SHORT") $KEYWORD=$i;
	   }
           else {
             for ($i=0; $i<$numkeywords; ++$i) if ($data[$i][0][0]=="NO KEY FOUND") $KEYWORD=$i;
	   }
           $KEYWORDSTRING=$data[$KEYWORD][0][0];
	}
	if ($Message==$LastMessage) {  // Repeat! Replace with "repeat input" keyword!
	   for ($i=0; $i<$numkeywords; ++$i) if ($data[$i][0][0]=="REPEAT INPUT") $KEYWORD=$i;
	}
	// Here we actually pick a response out of our little canned-response-database
	mt_srand(time()); //seed the randomness.
	$numphrases=count($data[$KEYWORD][1]);
	if ($numphrases==1) $RESPONSE=$data[$KEYWORD][1][0];
	else {
 	  $randphrase=mt_rand(0,$numphrases-1);
	  $RESPONSE=$data[$KEYWORD][1][$randphrase];
	}
	// Time to handle pronoun conjunction stuff, reversals
        /////RIGHT SIDE
	// bug:  add the multiple space squash mech here..
	$RIGHT=strtolower(trim($RIGHT));
	for ($token=strtok($RIGHT," "); $token !=""; $token=strtok(" ")) {
          for ($i=0; $i<count($reversals); ++$i) { // make any reversal corrections now
	    if ($token==$reversals[$i][0]) {
	      $token=$reversals[$i][1];
	      break;
	    }
	  }
	  $NEWRIGHT.=" ".$token;
	  if ($RIGHTFIRSTWORD=="") $RIGHTFIRSTWORD=$token;
	}
	$RIGHT=trim($NEWRIGHT);
//	for ($i=0; $i<count($corrections); ++$i) { // make any conjunctional corrections now
//	  $RIGHT=str_replace($corrections[$i][0],$corrections[$i][1],$RIGHT);
//	}

	// Time to handle pronoun conjunction stuff, reversals
        /////LEFT SIDE
	$LEFT=strtolower($LEFT);
	for ($token=strtok($LEFT," "); $token !=""; $token=strtok(" ")) {
          for ($i=0; $i<count($reversals); ++$i) { // make any reversal corrections now
	    if ($token==$reversals[$i][0]) {
	      $token=$reversals[$i][1];
	      break;
	    }
	  }
	  $NEWLEFT.=" ".$token;
	  $LEFTLASTWORD=trim($token);
	}
	$LEFT=trim($NEWLEFT);

	// whew.. no problem! finally,  just place the text after a keyword into the canned response if it wants it.
        $RESPONSE=str_replace("*><",$RIGHTFIRSTWORD,$RESPONSE);
        $RESPONSE=str_replace("*>",$RIGHT,$RESPONSE);
        $RESPONSE=str_replace("><*",$LEFTLASTWORD,$RESPONSE);	
        $RESPONSE=str_replace("<*",$LEFT,$RESPONSE);

	for ($i=0; $i<count($corrections); ++$i) { // make any conjunctional corrections now
	  $RESPONSE=str_replace($corrections[$i][0],$corrections[$i][1],$RESPONSE);
	}

	//return $RESPONSE."<BR>LEFT=$LEFT<BR>RIGHT=$RIGHT<BR>POS=$Pos<BR>Last:$LastMessage<BR>PADDED=$PADDEDMESSAGE<BR>KEYWORD=".$KEYWORDSTRING;
	return $RESPONSE;
}

?>
