<?
//////////////////////////////////////////////////////////////////////
////
////  MAHC - MAHC Advanced Html Chat Version 1.0.0
////  Complex Chat System Written in PHP4 Supporting HTML-only clients
////  Copyright (C) 2001 Joseph Durbin <jdurbin@users.sourceforge.net>
////  This Source is GNU GPL, See file LICENSE in distribution.
////
//////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// PROGRAM NAME: aichat.php
// AUTHOR: Joe Durbin
// DESCRIPTION: Web-based, 1 person Private AI chat, Component for MAHC
// FILES & DESCRIPTIONS:
//   aichat.php  - PHP4 Main Program File ($USERNAME & $OPPONENT are only external variables needed)
//   ai.php      - Actual AI Function (Old ELIZA test processor Style)
//   help/aichat.help - PHP4 Help Text for Program
//   data/$user.aichat - Custom Data File For Current Chat Data Between User & AI
//   data/$user.aichat.log - Log File For Chat Data Between User & AI
//
// DATE: 9/17/2001 aichat.php
//
////////////////////////////////////////////////////////////////  
	//// Verify Current Session ID Code. (prevent Hijacking of ID!)
	include("verifysessioncode.inc");
	include("prefs.inc");
	VerifySessionCode($USERNAME,$CODE);

	function ResetData() {  //Reset aichat data
		for ($i=0; $i<=26; $i++) $Board[$i]=""; 
		return $Board;
	}
	function WriteData($Board,$username,$newtext,$AI) {   //write privatechat data file
		//include("chatsmilies.inc");
		$DataFile=fopen("data/$username.aichat","w");
		if (!($DataFile)) die("Could not open AIChat Data File!!!");
		$newtext=stripcslashes($newtext);
		//$newtext=ChatSmilies($newtext); 
	        if ($AI!=1) fputs($DataFile,"<FONT COLOR=BLACK><B>$username:</B> $newtext</FONT>\n");
	        else fputs($DataFile,"<FONT COLOR=RED><B>Doc:</B> $newtext</FONT>\n");
		for ($i=1; $i<=20; $i++) fputs($DataFile,"$Board[$i]"); 
		fclose($DataFile);
		$DataFile=fopen("data/$username.aichat.log","a");
		if (!($DataFile)) die("Could not open AIChat Data File!!!");
	        if ($AI!=1) fputs($DataFile,"<FONT COLOR=BLACK><B>$username:</B> $newtext</FONT>\n");
	        else fputs($DataFile,"<FONT COLOR=RED><B>Doc:</B> $newtext</FONT>\n");
		fclose($DataFile);
	}
	function LoadData($username) {   //read privatechat data file
		$DataFile=fopen("data/$username.aichat","r");
		if (!($DataFile)) die("Could not open AIChat Data File!!!");
		$i=1;
		while (!feof($DataFile)) { 
			$Board[$i]=fgets($DataFile,255);
			++$i;
		}
		fclose($DataFile);
		return $Board;
	}
	

//////////////////////////////////////////[ BEGIN GAME ]/////////////////////////////////

if (file_exists("data/$USERNAME.aichat")) {
	$Board=LoadData($USERNAME);
} else {
	$NEWTEXT="Welcome! My name is Doc.  Please Tell me your troubles. I will try to help as best i can. Please use simple sentences when talking with me.  It allows me to fully understand your situation better.";
	$Board=ResetData();
	WriteData($Board,$USERNAME,$NEWTEXT,1);
	$NEWTEXT="";
};

if ($HELP==1) {
	require("help/aichat.help");
	exit();
}


if ($NEWTEXT!="") {
	WriteData($Board,$USERNAME,$NEWTEXT,0);
	$Board=LoadData($USERNAME);
	include("ai.php");
	$Response=AIChat($NEWTEXT,substr(strip_tags($Board[3]),strlen($USERNAME)+2,-1));
	WriteData($Board,$USERNAME,$Response,1);
}

if ($RESET==1) {
	$NEWTEXT="Welcome! My name is Doc.  Please Tell me your troubles. I will try to help as best i can. Please use simple sentences when talking with me.  It allows me to fully understand your situation better.";
	$Board=ResetData();
	WriteData($Board,$USERNAME,$NEWTEXT,1);
}


	if ($BOTTOM==1) {
		print ("<HTML><HEAD>");
		print ("<meta http-equiv=\"refresh\" content=\"$REFRESHPRIVATECHAT;URL=aichat.php?USERNAME=$USERNAME&CODE=$CODE&BOTTOM=1\">");
		print ("</HEAD><BODY BGCOLOR=$SHADOW2 HLINK=$HLINK VLINK=$VLINK ALINK=$ALINK MARGINHEIGHT=2 TOPMARGIN=2 >$FONT");
		for ($i=1; $i<=20; $i++) print ("$Board[$i]<BR>");
		print ("</HTML>");
	} else if ($TOP==1) {
		print ("<HTML><HEAD><meta http-equiv=\"refresh\" content=\"300;URL=aichat.php?USERNAME=$USERNAME&CODE=$CODE&TOP=1\"></HEAD>");
		print ("<BODY BGCOLOR=$ACCENT2 MARGINHEIGHT=2 TOPMARGIN=2 HLINK=$HLINK VLINK=$VLINK ALINK=$ALINK>");
		print ("<CENTER><TABLE BGCOLOR=EEEEEE CELLPADDING=2 CELLSPACING=0 BORDER=1><FORM METHOD=POST ACTION=\"aichat.php\">");
		print ("<TR><TD><CENTER><B><FONT SIZE=+1 COLOR=BLUE>DOCTOR CHAT</FONT><BR>");
		print (" (<FONT COLOR=BLACK>$USERNAME</FONT> with <FONT COLOR=RED>Doc</FONT>)</B><BR>");
		print ("<INPUT TYPE=HIDDEN NAME=USERNAME VALUE=$USERNAME>");
		print ("<INPUT TYPE=HIDDEN NAME=CODE VALUE=$CODE>");
		print ("<INPUT TYPE=HIDDEN NAME=TOP VALUE=1>");
		print ("<INPUT TYPE=TEXT NAME=NEWTEXT><INPUT TYPE=SUBMIT VALUE=SEND><BR>");
		print ("<A HREF=\"welcome.php?USERNAME=$USERNAME&CODE=$CODE&CLOSE=1\" TARGET=LEFT>CLOSE CHAT</A> - "); 
		print ("<A HREF=\"aichat.php?RESET=1&USERNAME=$USERNAME&CODE=$CODE&TOP=1\">CLEAR CHAT</A> - ");
		print ("<A HREF=\"aichat.php?USERNAME=$USERNAME&CODE=$CODE&HELP=1\" TARGET=LEFT>HELP</A>");
		print ("</TD></TR></FORM></TABLE></HTML>");
	} else {
		print ("<HTML><FRAMESET BORDER=1 ROWS=100,100% FRAMEBORDER=0 FRAMESPACING=1 SCROLLING=auto>");
		print ("<FRAME BORDER=0 FRAMEBORDER=0 NAME=PRIVTOP SCROLLING=no SRC=\"aichat.php?USERNAME=$USERNAME&CODE=$CODE&TOP=1\">");
		print ("<FRAME BORDER=0 FRAMEBORDER=0 NAME=PRIVBOT SCROLLING=auto SRC=\"aichat.php?USERNAME=$USERNAME&CODE=$CODE&BOTTOM=1\">");
		print ("</FRAMESET></HTML>");
		
	}
?>
