<?
//////////////////////////////////////////////////////////////////////
////
////  MAHC - MAHC Advanced Html Chat Version 1.0.0
////  Complex Chat System Written in PHP4 Supporting HTML-only clients
////  Copyright (C) 2001 Joseph Durbin <jdurbin@users.sourceforge.net>
////  This Source is GNU GPL, See file LICENSE in distribution.
////
//////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// PROGRAM NAME: checkers.php
// AUTHOR: Joe Durbin
// DESCRIPTION: Web-based, 2 player Checkers Game Component for MAHC
// FILES & DESCRIPTIONS:
//   checkers.php  - PHP4 Main Program File ($USERNAME & $OPPONENT are only external variables needed)
//   help/checkers.help - PHP4 Help Text for Program
//   data/$user-$user.checkers - Custom Data File For Current Game Data Between 2 Users
//   graphics/check-* - Piece Graphics for GameBoard
//
// DATE: 11/17/2000 checkers.php VERSION: 1.0 CHANGES: First Version
//
////////////////////////////////////////////////////////////////  
	//// Verify Current Session ID Code. (prevent Hijacking of ID!)
	include("verifysessioncode.inc");
	VerifySessionCode($USERNAME,$CODE);

	function Setup($username,$opponent) {
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Mode,$SelX,$SelY;
		if ($username<$opponent) {
			$Player[1]=$username;  //B(lack)
			$Player[2]=$opponent;  //R(ed)
		} else {
			$Player[1]=$opponent;  //B
			$Player[2]=$username;  //R
		};	
		$PlayersTurn=1;
		$PlayerScore[1]=0;  //B
		$PlayerScore[2]=0;  //R
	}

	function ResetData() {  //Reset gameboard data and switch playersturn to opposite that started last game.
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Mode,$SelX,$SelY;
		for ($i=1; $i<=8; $i++)
			for ($j=1; $j<=8; $j++) {
				$Board[$i][$j]=" ";
				if ((($i+$j+1)/2==floor(($i+$j+1)/2))&&($j<=3)) $Board[$i][$j]="b";  //b-normal black, B-Queen black
				if ((($i+$j+1)/2==floor(($i+$j+1)/2))&&($j>=6)) $Board[$i][$j]="r";  //r-normal red, R-Queen red

			} 
		if ($PlayerWhoStartedGame==1) $PlayerWhoStartedGame=2; else $PlayerWhoStartedGame=1;
		$PlayersTurn=$PlayerWhoStartedGame; 
		$GameInPlay=1;
		$CurrentWinner=0;
		$Mode=1;
		$SelX=0; $SelY=0;
		return $Board;
	}
	function WriteData($Board) {   //write game data file
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Mode,$SelX,$SelY;
		$DataFile=fopen("data/$Player[1]-$Player[2].checkers","w");
		if (!($DataFile)) die("Could not open Game Data File!!!");
		fputs($DataFile,"$GameInPlay:$PlayersTurn:$PlayerScore[1]:$PlayerScore[2]:$PlayerWhoStartedGame:$CurrentWinner:$Mode:$SelX:$SelY\n");
		for ($i=1; $i<=8; $i++) {
			for ($j=1; $j<=8; $j++) {
				if ($Board[$j][$i]=="") $Board[$j][$i]=" ";
				fputs($DataFile,"{$Board[$j][$i]}:");
			};
			fputs($DataFile,"\n");
		};
		fclose($DataFile);
	}
	function LoadData() {   //read game data file
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Mode,$SelX,$SelY;
		$DataFile=fopen("data/$Player[1]-$Player[2].checkers","r");
		if (!($DataFile)) die("Could not openGame Data File!!!");
		$Line		=	fgetcsv($DataFile,255,":");
		$GameInPlay	=	$Line[0];
		$PlayersTurn	=	$Line[1];
		$PlayerScore[1]	=	$Line[2];
		$PlayerScore[2]	=	$Line[3];
		$PlayerWhoStartedGame=	$Line[4];
		$CurrentWinner	=	$Line[5];
		$Mode		=	$Line[6];
		$SelX		=	$Line[7];
		$SelY		=	$Line[8];
		for ($i=1; $i<=8; $i++) {
			$Line=fgetcsv($DataFile,255,":");
			for ($j=1; $j<=8; $j++) {
				$Board[$j][$i]=$Line[$j-1];
				if ($Board[$j][$i]=="") $Board[$j][$i]=" ";
			}
		}
		fclose($DataFile);
		return $Board;
	}
	
	function MovePiece($Board, $x,$y,$killx,$killy) {  // choose game piece
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Mode,$SelX,$SelY;
		$Board[$x][$y]=$Board[$SelX][$SelY];  //copy piece to new position
		$Board[$SelX][$SelY]=" ";   //remove from old position.
		if (($y==1)&&($Board[$x][$y]=="r")) $Board[$x][$y]="R"; //Queening code
		if (($y==8)&&($Board[$x][$y]=="b")) $Board[$x][$y]="B";
		$Board[$killx][$killy]=" "; //remove jumped piece
		return $Board;
	}

	function ToggleTurn() {
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Mode,$SelX,$SelY;
		if ($PlayersTurn==1) $PlayersTurn=2; else $PlayersTurn=1;
		$Mode=1;
	}

	function CheckWinner($Board) { //Returns 0=no winner; 1=1stplayer; 2=2nd player
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Mode,$SelX,$SelY;
		$RedCount=0; $BlackCount=0;
		for ($i=1; $i<=8; $i++) { 
			for ($j=1; $j<=8; $j++) {
				if ($Board[$j][$i]=="b") ++$BlackCount;
				if ($Board[$j][$i]=="B") ++$BlackCount;
				if ($Board[$j][$i]=="r") ++$RedCount;
				if ($Board[$j][$i]=="R") ++$RedCount;
			}
		}
		if ($BlackCount==0) $CurrentWinner=2;
		if ($RedCount==0) $CurrentWinner=1;
		++$PlayerScore[$CurrentWinner];
	}

	function Background() {  // makes tiles checkered
		static $EveryOther;
		if ($EveryOther==0) {
			$EveryOther=1;
			$Back="r";
		} else {
			$EveryOther=0;
			$Back="b";
		};
		return $Back;
	}
	function DrawPiece($CH,$MARK) {
		$IMG="<IMG BORDER=0 WIDTH=36 HEIGHT=36 SRC=graphics/check-";
		$IMG.=Background();
		if ($CH=="r") $IMG.="r";
		if ($CH=="b") $IMG.="b";
		if ($CH=="R") $IMG.="rk";
		if ($CH=="B") $IMG.="bk";
		if ($MARK=="1") $IMG.="y";
		$IMG.=">";
		return $IMG;
	}
	function AnalyzeMoves($Board,$x,$y) {
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Mode,$SelX,$SelY;
		//MoveData[X possible move][Y possible move][X piece Kill][Y piece kill]
		$NumMoves=0;
		if (($Board[$x][$y]=="b")||($Board[$x][$y]=="B")) {
			if (($y<=7)&&($x>=2))
				if ($Board[$x-1][$y+1]==" ") {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x-1;
					$MoveData[$NumMoves][1]=$y+1;
					$MoveData[$NumMoves][2]=0;
					$MoveData[$NumMoves][3]=0;
				}
			if (($y<=7)&&($x<=7))
				if ($Board[$x+1][$y+1]==" ") {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x+1;
					$MoveData[$NumMoves][1]=$y+1;
					$MoveData[$NumMoves][2]=0;
					$MoveData[$NumMoves][3]=0;
				}
			if (($y<=6)&&($x>=3))
				if (($Board[$x-1][$y+1]!="b")&&($Board[$x-1][$y+1]!="B")&&($Board[$x-1][$y+1]!=" ")&&($Board[$x-2][$y+2]==" ")) {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x-2;
					$MoveData[$NumMoves][1]=$y+2;
					$MoveData[$NumMoves][2]=$x-1;
					$MoveData[$NumMoves][3]=$y+1;
				}
			if (($y<=6)&&($x<=6))
				if (($Board[$x+1][$y+1]!="b")&&($Board[$x+1][$y+1]!="B")&&($Board[$x+1][$y+1]!=" ")&&($Board[$x+2][$y+2]==" ")) {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x+2;
					$MoveData[$NumMoves][1]=$y+2;
					$MoveData[$NumMoves][2]=$x+1;
					$MoveData[$NumMoves][3]=$y+1;
				}
		}
		if ($Board[$x][$y]=="B") {
			if (($y>=2)&&($x>=2))
				if ($Board[$x-1][$y-1]==" ") {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x-1;
					$MoveData[$NumMoves][1]=$y-1;
					$MoveData[$NumMoves][2]=0;
					$MoveData[$NumMoves][3]=0;
				}
			if (($y>=2)&&($x<=7))
				if ($Board[$x+1][$y-1]==" ") {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x+1;
					$MoveData[$NumMoves][1]=$y-1;
					$MoveData[$NumMoves][2]=0;
					$MoveData[$NumMoves][3]=0;
				}
			if (($y>=3)&&($x>=3))
				if (($Board[$x-1][$y-1]!="b")&&($Board[$x-1][$y-1]!="B")&&($Board[$x-1][$y-1]!=" ")&&($Board[$x-2][$y-2]==" ")) {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x-2;
					$MoveData[$NumMoves][1]=$y-2;
					$MoveData[$NumMoves][2]=$x-1;
					$MoveData[$NumMoves][3]=$y-1;
				}
			if (($y>=3)&&($x<=6))
				if (($Board[$x+1][$y-1]!="b")&&($Board[$x+1][$y-1]!="B")&&($Board[$x+1][$y-1]!=" ")&&($Board[$x+2][$y-2]==" ")) {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x+2;
					$MoveData[$NumMoves][1]=$y-2;
					$MoveData[$NumMoves][2]=$x+1;
					$MoveData[$NumMoves][3]=$y-1;
				}
		}
		if (($Board[$x][$y]=="r")||($Board[$x][$y]=="R")) {
			if (($y>=2)&&($x>=2))
				if ($Board[$x-1][$y-1]==" ") {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x-1;
					$MoveData[$NumMoves][1]=$y-1;
					$MoveData[$NumMoves][2]=0;
					$MoveData[$NumMoves][3]=0;
				}
			if (($y>=2)&&($x<=7))
				if ($Board[$x+1][$y-1]==" ") {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x+1;
					$MoveData[$NumMoves][1]=$y-1;
					$MoveData[$NumMoves][2]=0;
					$MoveData[$NumMoves][3]=0;
				}
			if (($y>=3)&&($x>=3))
				if (($Board[$x-1][$y-1]!="r")&&($Board[$x-1][$y-1]!="R")&&($Board[$x-1][$y-1]!=" ")&&($Board[$x-2][$y-2]==" ")) {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x-2;
					$MoveData[$NumMoves][1]=$y-2;
					$MoveData[$NumMoves][2]=$x-1;
					$MoveData[$NumMoves][3]=$y-1;
				}
			if (($y>=3)&&($x<=6))
				if (($Board[$x+1][$y-1]!="r")&&($Board[$x+1][$y-1]!="R")&&($Board[$x+1][$y-1]!=" ")&&($Board[$x+2][$y-2]==" ")) {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x+2;
					$MoveData[$NumMoves][1]=$y-2;
					$MoveData[$NumMoves][2]=$x+1;
					$MoveData[$NumMoves][3]=$y-1;
				}
		}
		if ($Board[$x][$y]=="R") {
			if (($y<=7)&&($x>=2))
				if ($Board[$x-1][$y+1]==" ") {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x-1;
					$MoveData[$NumMoves][1]=$y+1;
					$MoveData[$NumMoves][2]=0;
					$MoveData[$NumMoves][3]=0;
				}
			if (($y<=7)&&($x<=7))
				if ($Board[$x+1][$y+1]==" ") {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x+1;
					$MoveData[$NumMoves][1]=$y+1;
					$MoveData[$NumMoves][2]=0;
					$MoveData[$NumMoves][3]=0;
				}
			if (($y<=6)&&($x>=3))
				if (($Board[$x-1][$y+1]!="r")&&($Board[$x-1][$y+1]!="R")&&($Board[$x-1][$y+1]!=" ")&&($Board[$x-2][$y+2]==" ")) {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x-2;
					$MoveData[$NumMoves][1]=$y+2;
					$MoveData[$NumMoves][2]=$x-1;
					$MoveData[$NumMoves][3]=$y+1;
				}
			if (($y<=6)&&($x<=6))
				if (($Board[$x+1][$y+1]!="r")&&($Board[$x+1][$y+1]!="R")&&($Board[$x+1][$y+1]!=" ")&&($Board[$x+2][$y+2]==" ")) {
					++$NumMoves;
					$MoveData[$NumMoves][0]=$x+2;
					$MoveData[$NumMoves][1]=$y+2;
					$MoveData[$NumMoves][2]=$x+1;
					$MoveData[$NumMoves][3]=$y+1;
				}
		}

		$MoveData[0][0]=$NumMoves;
		if ($NumMoves==0) $Mode=1;
		return $MoveData;
	}
	
//////////////////////////////////////////[ BEGIN GAME ]/////////////////////////////////
Setup($USERNAME,$OPPONENT);

if (file_exists("data/$Player[1]-$Player[2].checkers")) {
	$Board=LoadData();
} else {
	$Board=ResetData();
	WriteData($Board);
};	

if ($RESET==1) {
	$Board=ResetData();
	WriteData($Board);
}

include("managecurrentusers.inc");
if (GetPartner($OPPONENT)!=$USERNAME) {
	print("<HTML><CENTER><FONT SIZE=+2 COLOR=RED>$OPPONENT Has Closed The Game.<BR>To Exit, Click ");
	print ("<A HREF=\"welcome.php?USERNAME=$USERNAME&CODE=$CODE&CLOSE=1\" TARGET=LEFT>HERE</A>.</HTML>");
	exit();
}    

if ($HELP==1) {
	require("help/checkers.help");
	exit();
}

if (($Mode==1)&&($X>0)&&($Y>0)&&($Player[$PlayersTurn]==$USERNAME)) {
	//$Board=PickPiece($Board,$X,$Y);
	//CheckWinner($Board);
	//ToggleTurn();
	$Mode=2;
	$SelX=$X;
	$SelY=$Y;
	WriteData($Board);
};


if (($Mode==2)&&($Player[$PlayersTurn]==$USERNAME)) {
	$MoveData=AnalyzeMoves($Board,$SelX,$SelY);
	if ($Mode==1) {
		$SelX=0; $SelY=0;
		WriteData($Board);
	}
}

if (($Mode==2)&&($X>0)&&($Y>0)&&(isset($KILLX))&&($Player[$PlayersTurn]==$USERNAME)) {
	$Board=MovePiece($Board,$X,$Y,$KILLX,$KILLY);
	CheckWinner($Board);
	ToggleTurn();
	WriteData($Board);
};

if ($Player[$PlayersTurn]==$USERNAME) $MyTurn=1; Else $MyTurn=0;
?>

<HTML><HEAD>
<? 
	if ($MyTurn==1) $Refresh=15; else $Refresh=7;
	print("<meta http-equiv=\"refresh\" content=\"$Refresh;URL=checkers.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE\">");
?>
</HEAD><BODY BGCOLOR=FFFFFF HLINK=BLUE VLINK=BLUE ALINK=BLUE>
<CENTER>
<B><FONT SIZE=+2 COLOR=BLUE>CHECKERS<BR>
<? print("$Player[1] vs. $Player[2]"); ?>
<BR></FONT>
<FONT SIZE=+1>
- <? 
if ($CurrentWinner==0) { 
	print ("$Player[$PlayersTurn]'s turn");
	if ($Mode==1) print"(Choosing Piece)";
	if ($Mode==2) print"(Choosing Move)";
} else print ("<FONT COLOR=RED SIZE=+2>$Player[$CurrentWinner] wins the game!</FONT>");
?> -
<BR>

<? 

for ($i=1; $i<=8; $i++) {
	print "";
	for ($j=1; $j<=8; $j++) {
		print "";
		if ($Mode==1) {
			if (($MyTurn==1)&&($PlayersTurn==1)&&(($Board[$j][$i]=="B")||($Board[$j][$i]=="b"))) 
				print ("<A HREF=\"checkers.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&X=$j&Y=$i&CODE=$CODE\">".DrawPiece($Board[$j][$i],0)."</A>");
			else if (($MyTurn==1)&&($PlayersTurn==2)&&(($Board[$j][$i]=="R")||($Board[$j][$i]=="r"))) 
				print ("<A HREF=\"checkers.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&X=$j&Y=$i&CODE=$CODE\">".DrawPiece($Board[$j][$i],0)."</A>");
			else print DrawPiece($Board[$j][$i],0);
		}
		if ($Mode==2) {
			if ($MyTurn==1) {
				$found=0;
				for ($k=1; $k<=$MoveData[0][0]; $k++) {
					if (($MoveData[$k][0]==$j)&&($MoveData[$k][1]==$i)) {
						print ("<A HREF=\"checkers.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&X=$j&Y=$i&CODE=$CODE&KILLX={$MoveData[$k][2]}&KILLY={$MoveData[$k][3]}\">".DrawPiece($Board[$j][$i],1)."</A>");
						$found=1;
					}
				}
				if ($found==0) print DrawPiece($Board[$j][$i],0);
			} else print DrawPiece($Board[$j][$i],"");
		}
		print "";
	};
	Background();
	print"<BR>";
};
?>
<BR>
<A HREF="welcome.php?USERNAME=<? print"$USERNAME&CODE=$CODE"; ?>&CLOSE=1" TARGET=LEFT>
CLOSE GAME</A> - 
<? print ("<A HREF=\"checkers.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&RESET=1\">"); ?>
NEW GAME</A> - 
<? print ("<A HREF=\"checkers.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&HELP=1\">"); ?>
HELP</A>
<BR></FONT>
OVERALL SCORE:  
<? print("$Player[1](Black) $PlayerScore[1] games; $Player[2](Red) $PlayerScore[2] games"); ?>
<BR>

</CENTER></BODY></HTML>
