<?
//////////////////////////////////////////////////////////////////////
////
////  MAHC - MAHC Advanced Html Chat Version 1.0.0
////  Complex Chat System Written in PHP4 Supporting HTML-only clients
////  Copyright (C) 2001 Joseph Durbin <jdurbin@users.sourceforge.net>
////  This Source is GNU GPL, See file LICENSE in distribution.
////
//////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// PROGRAM NAME: crossword.php
// AUTHOR: Joe Durbin
// DESCRIPTION: Web-based, 2 player crossword Game, Component for FUNCHAT
// FILES & DESCRIPTIONS:
//   crossword.php  - PHP4 Main Program File ($USERNAME & $OPPONENT are only external variables needed)
//   help/crossword.help - PHP4 Help Text for Program
//   data/$user-$user.crossword - Custom Data File For Current Game Data Between 2 Users
//
// DATE: 11/17/2000 crossword.php VERSION: 1.0 CHANGES: First Version
//
////////////////////////////////////////////////////////////////  
	//// Verify Current Session ID Code. (prevent Hijacking of ID!)
	include("verifysessioncode.inc");
	VerifySessionCode($USERNAME,$CODE);

	function Setup($username,$opponent) {
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$CurrentScore,$Placement,$Racks,$Tiles;
		if ($username<$opponent) {
			$Player[1]=$username;  //1st
			$Player[2]=$opponent;  //2nd
		} else {
			$Player[1]=$opponent;  //1st
			$Player[2]=$username;  //2nd
		};	
		$PlayersTurn=1;
		$PlayerScore[1]=0;  //1st
		$PlayerScore[2]=0;  //2nd
	}
	
	function Mirror($Board,$x,$y,$value) {
		$Board[$x][$y]=$value;
		$Board[16-$x][$y]=$value;
		$Board[$x][16-$y]=$value;
		$Board[16-$x][16-$y]=$value;
		return $Board;
	}

	function ChooseTile($Player,$Piece,$ReturnTile) {
		global $Tiles,$Racks;
		$found=0;
		if ($Piece>=10) { $Piece-=10; ++$Player; }
		for ($i=1; $i<=27; $i++) $found+=$Tiles[$i];
		if ($found>=1) {
			if ($ReturnTile==1) 
				++$Tiles[ord($Racks[($Player-1)*10+$Piece])-96];
			$j=rand(1,$found); $k=$Tiles[1]; $i=1; 
			while ($k<$j) {
				++$i;
				$k+=$Tiles[$i];
			}	
			$Racks[($Player-1)*10+$Piece]=chr($i+96); //Set New letter in rack position
			--$Tiles[$i]; // subtract piece from unused tiles
		} else $Racks[($Player-1)*10+$Piece]=0; //Set New letter in rack position
		return $found;
	}

	function ResetData() {  //Reset gameboard data and switch playersturn to opposite that started last game.
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$CurrentScore,$Placement,$Racks,$Tiles;
		for ($i=1; $i<=15; $i++)
			for ($j=1; $j<=15; $j++) $Board[$i][$j]="0"; 

		$Board=Mirror($Board,7,7,1);  //Set Double Letter Squares
		$Board=Mirror($Board,4,1,1);
		$Board=Mirror($Board,1,4,1);
		$Board=Mirror($Board,7,3,1);
		$Board=Mirror($Board,3,7,1);
		$Board=Mirror($Board,8,4,1);
		$Board=Mirror($Board,4,8,1);
		$Board=Mirror($Board,6,2,2);  //Set Triple Letter Squares
		$Board=Mirror($Board,2,6,2);
		$Board=Mirror($Board,6,6,2);
		for ($i=2; $i<=5; $i++) 
			$Board=Mirror($Board,$i,$i,3);  //Set Double Word Squares
		$Board[8][8] = 3;  // Center Square
		$Board=Mirror($Board,1,1,4);  //Set Triple Word Squares
		$Board[1][8] = 4;	
		$Board[8][1] = 4;	
		$Board[8][15]= 4;		
		$Board[15][8]= 4;	
		$Tiles[1]=9; //number of A tiles
		$Tiles[2]=2; //Number of B tiles
		$Tiles[3]=2;
		$Tiles[4]=4;
		$Tiles[5]=12;
		$Tiles[6]=2;
		$Tiles[7]=3;
		$Tiles[8]=2;
		$Tiles[9]=9;
		$Tiles[10]=1;
		$Tiles[11]=1;
		$Tiles[12]=4;
		$Tiles[13]=2;
		$Tiles[14]=6;
		$Tiles[15]=8;
		$Tiles[16]=2;
		$Tiles[17]=1;
		$Tiles[18]=6;
		$Tiles[19]=4;
		$Tiles[20]=6;
		$Tiles[21]=4;
		$Tiles[22]=2;
		$Tiles[23]=2;
		$Tiles[24]=1;
		$Tiles[25]=2;
		$Tiles[26]=1; //Number of Z tiles
		$Tiles[27]=0; //Number of Blank Tiles (should be 2)

		if ($PlayerWhoStartedGame==1) $PlayerWhoStartedGame=2; else $PlayerWhoStartedGame=1;
		$PlayersTurn=$PlayerWhoStartedGame; 
		$GameInPlay=1;
		$CurrentWinner=0;
		$CurrentScore[1]=0;
		$CurrentScore[2]=0;
		for ($i=1; $i<=7; $i++) {
			ChooseTile(1,$i,0);
			ChooseTile(2,$i,0);
		}
		for ($i=1; $i<=29; $i++) $Placement[$i]=0;
		return $Board;
	}
	function WriteData($Board) {   //write game data file
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$CurrentScore,$Placement,$Racks,$Tiles;
		$DataFile=fopen("data/$Player[1]-$Player[2].crossword","w");
		if (!($DataFile)) die("Could not open Game Data File!!!");
		fputs($DataFile,"$GameInPlay:$PlayersTurn:$PlayerScore[1]:$PlayerScore[2]:$PlayerWhoStartedGame:$CurrentWinner:$CurrentScore[1]:$CurrentScore[2]:\n");
		for ($i=1; $i<=29; $i++)  fputs($DataFile,"$Placement[$i]:");
		fputs($DataFile,"\n");
		for ($i=1; $i<=20; $i++)  fputs($DataFile,"$Racks[$i]:");
		fputs($DataFile,"\n");
		for ($i=1; $i<=27; $i++)  fputs($DataFile,"$Tiles[$i]:");
		fputs($DataFile,"\n");
		for ($j=1; $j<=15; $j++) {
			for ($i=1; $i<=15; $i++) fputs($DataFile,"{$Board[$i][$j]}:");
			fputs($DataFile,"\n");
		}
		fclose($DataFile);
	}
	function LoadData() {   //read game data file
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$CurrentScore,$Placement,$Racks,$Tiles;
		$DataFile=fopen("data/$Player[1]-$Player[2].crossword","r");
		if (!($DataFile)) die("Could not openGame Data File!!!");
		$Line		=	fgetcsv($DataFile,255,":");
		$GameInPlay	=	$Line[0];
		$PlayersTurn	=	$Line[1];
		$PlayerScore[1]	=	$Line[2];
		$PlayerScore[2]	=	$Line[3];
		$PlayerWhoStartedGame=	$Line[4];
		$CurrentWinner	=	$Line[5];
		$CurrentScore[1]=	$Line[6];
		$CurrentScore[2]=	$Line[7];
		$Line		=	fgetcsv($DataFile,255,":");
		for ($i=1; $i<=29; $i++) $Placement[$i]=$Line[$i-1];
		$Line		=	fgetcsv($DataFile,255,":");
		for ($i=1; $i<=20; $i++) $Racks[$i]=$Line[$i-1];
		$Line		=	fgetcsv($DataFile,255,":");
		for ($i=1; $i<=27; $i++) $Tiles[$i]=$Line[$i-1];
		for ($j=1; $j<=15; $j++) {
			$Line=fgetcsv($DataFile,255,":");
			for ($i=1; $i<=15; $i++) {
				$Board[$i][$j]=$Line[$i-1];
			}
		}
		for ($i=0; $i<=16; $i++) {  //Buffer $Board with 0's on array border
			$Board[0][$i]=0;
			$Board[16][$i]=0;
			$Board[$i][0]=0;
			$Board[$i][16]=0;
		}
		fclose($DataFile);
		return $Board;
	}
	
	function ScoreWord($Board,$x1,$y1,$x2,$y2) {
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$CurrentScore,$Placement,$Racks,$Tiles;
		//print "<B><BR>Scoring: $x1,$y1 - $x2,$y2</B>";
		$Value[1]=1; //Value of Tile A
		$Value[2]=3; //Value of Tile B
		$Value[3]=3;
		$Value[4]=2;
		$Value[5]=1;
		$Value[6]=4;
		$Value[7]=2;
		$Value[8]=4;
		$Value[9]=1;
		$Value[10]=8;
		$Value[11]=5;
		$Value[12]=1;
		$Value[13]=3;
		$Value[14]=1;
		$Value[15]=1;
		$Value[16]=3;
		$Value[17]=10;
		$Value[18]=1;
		$Value[19]=1;
		$Value[20]=1;
		$Value[21]=1;
		$Value[22]=4;
		$Value[23]=4;
		$Value[24]=8;
		$Value[25]=4;
		$Value[26]=10; //Value of Z tile
		$Value[27]=0; // Value of Blank Tile
		$WordMultiplier=1;
		$Score=0;
		$Horizontal=0; $Vertical=0;
		$Length=0;
		if ($x1<$x2) { //determine length and direction of word
			$Length=$x2-$x1;
			$Horizontal=1;
		} else {
			$Length=$y2-$y1;
			$Vertical=1;
		}
		for ($i=0; $i<=$Length; $i++) { //Loop through each letterof word
			$CurX=$x1+($Horizontal*$i); // Current X
			$CurY=$y1+($Vertical*$i); //Current Y
			if (ord($Board[$CurX][$CurY])>=96) { //it is a letter
				$Score+=$Value[ord($Board[$CurX][$CurY])-96];
				$Word[$i]=$Board[$CurX][$CurY];
			} else { //It's a number
				$j=29;
				while (($Placement[$j]==0)&&($j>=1)) --$j;
				$NumberPlayed=floor($j/4);
				for ($j=1; $j<=$NumberPlayed; $j++) {
					if (($Placement[$j*4-1]==$CurX)&&($Placement[$j*4]==$CurY)) {
						$Word[$i]=$Racks[$Placement[$j*4-2]];
						if ($Board[$CurX][$CurY]==0) { //Tile is placed on a normal square
							$Score+=$Value[ord($Racks[$Placement[$j*4-2]])-96];
						}
						if ($Board[$CurX][$CurY]==1) { //Tile is placed on a double letter square
							$Score+=2*$Value[ord($Racks[$Placement[$j*4-2]])-96];
						}
						if ($Board[$CurX][$CurY]==2) { //Tile is placed on a triple letter square
							$Score+=3*$Value[ord($Racks[$Placement[$j*4-2]])-96];
						}
						if ($Board[$CurX][$CurY]==3) { //Tile is placed on a double word square
							$Score+=$Value[ord($Racks[$Placement[$j*4-2]])-96];
							$WordMultiplier*=2;
						}
						if ($Board[$CurX][$CurY]==4) { //Tile is placed on a triple word square
							$Score+=$Value[ord($Racks[$Placement[$j*4-2]])-96];
							$WordMultiplier*=3;
						}
					}
				}		
			}
		}
		$Score=$Score*$WordMultiplier;  // Add the double/triple word score multiplications
		$WholeWord="";
		for ($i=0; $i<=$Length; $i++) $WholeWord.=$Word[$i]; // concat array to single word
		//print "Scoring word: ($WholeWord) $Score pts<BR>";
		if (VerifyWord($WholeWord)==0) $Score=-1;  // Word not valid
		return $Score;	// Returns Word Value, or -1 if not a valid word
	}

	function ComputeScore($Board) {
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$CurrentScore,$Placement,$Racks,$Tiles;
		$Horizontal=0; $Vertical=0; $AllGood=1; $TotalScore=0;
		$MinX=0; $MinY=0; $MaxX=0; $MaxY=0; //Bounds of discovered word.
		$i=29;
		while (($Placement[$i]==0)&&($i>=1)) --$i;
		$NumberPlayed=floor($i/4);
		if ($NumberPlayed==1) {  // A Single Letter Is Placed, Special Handling(at most 2 words +)
			$MinX=$Placement[3]; $MinY=$Placement[4];
			if ((ord($Board[$MinX-1][$MinY])>=96)||(ord($Board[$MinX+1][$MinY])>=96)) {
				$MaxY=$MinY; $MaxX=$MinX;
				while (ord($Board[$MinX-1][$MinY])>=96) --$MinX;
				while (ord($Board[$MaxX+1][$MaxY])>=96) ++$MaxX;
				$T=ScoreWord($Board,$MinX,$MinY,$MaxX,$MaxY);
				if ($T==-1) $AllGood=0; else $TotalScore+=$T;
			}	
			$MinX=$Placement[3]; $MinY=$Placement[4];
			if ((ord($Board[$MinX][$MinY-1])>=96)||(ord($Board[$MinX][$MinY+1])>=96)) {
				$MaxX=$MinX; $MaxY=$MinY;
				while (ord($Board[$MinX][$MinY-1])>=96) --$MinY;
				while (ord($Board[$MaxX][$MaxY+1])>=96) ++$MaxY;
				$T=ScoreWord($Board,$MinX,$MinY,$MaxX,$MaxY);
				if ($T==-1) $AllGood=0; else $TotalScore+=$T;
			}
			if ($TotalScore==0) $AllGood=0;  // if they didn't score anything, it must be a bad word 	
		} else if ($NumberPlayed>1) {
			$Touching=0; // the following loop makes sure it's touching other letters , or center.
			for ($i=1; $i<=$NumberPlayed; $i++) {
				if (($Placement[$i*4-1]==8)&&($Placement[$i*4]==8)) $Touching=1;
				if (ord($Board[$Placement[$i*4-1]-1][$Placement[$i*4]])>=96) $Touching=1;
				if (ord($Board[$Placement[$i*4-1]+1][$Placement[$i*4]])>=96) $Touching=1;
				if (ord($Board[$Placement[$i*4-1]][$Placement[$i*4]-1])>=96) $Touching=1;
				if (ord($Board[$Placement[$i*4-1]][$Placement[$i*4]+1])>=96) $Touching=1;
			}
			if ($Touching==0) $AllGood=0;  // not good placement, if didn't touch any other letters
			if ($Placement[3]==$Placement[7]) $Vertical=1; else $Horizontal=1;
			$MinX=$Placement[3]; $MaxX=$MinX;
			$MinY=$Placement[4]; $MaxY=$MinY;
			for ($i=1; $i<=$NumberPlayed; $i++) $Used[$i]=0;  // set all letters to "unused"
			$Moved=1; $Used[1]=1;
			while ($Moved==1) {
				$Moved=0;
				for ($i=1; $i<=$NumberPlayed; $i++) {
					if ((ord($Board[$MinX-$Horizontal][$MinY-$Vertical])>=96)||(($MinX-$Horizontal==$Placement[$i*4-1])&&($MinY-$Vertical==$Placement[$i*4]))) {
						if (($MinX-$Horizontal==$Placement[$i*4-1])&&($MinY-$Vertical==$Placement[$i*4])) $Used[$i]=1;
						$MinX-=$Horizontal; $MinY-=$Vertical; $Moved=1;
					}
					if ((ord($Board[$MaxX+$Horizontal][$MaxY+$Vertical])>=96)||(($MaxX+$Horizontal==$Placement[$i*4-1])&&($MaxY+$Vertical==$Placement[$i*4]))) {
						if (($MaxX+$Horizontal==$Placement[$i*4-1])&&($MaxY+$Vertical==$Placement[$i*4])) $Used[$i]=1;
						$MaxX+=$Horizontal; $MaxY+=$Vertical; $Moved=1;
					}

				}
			}
			for ($i=1; $i<=$NumberPlayed; $i++) if ($Used[$i]==0) $AllGood=0;  // check to make sure all letters were used
			$T=ScoreWord($Board,$MinX,$MinY,$MaxX,$MaxY);
			if ($T==-1) $AllGood=0; else $TotalScore+=$T;
			//////////// Need to Search for Secondary words now (perpendicular)
			for ($i=1; $i<=$NumberPlayed; $i++) {
				if ((ord($Board[$Placement[$i*4-1]-$Vertical][$Placement[$i*4]-$Horizontal])>=96)||(ord($Board[$Placement[$i*4-1]+$Vertical][$Placement[$i*4]+$Horizontal])>=96)) {
					if ($Vertical==1) {
						$MinX=$Placement[$i*4-1];
						$MinY=$Placement[$i*4];
						$MaxY=$MinY; $MaxX=$MinX;
						while (ord($Board[$MinX-1][$MinY])>=96) --$MinX;
						while (ord($Board[$MaxX+1][$MaxY])>=96) ++$MaxX;
					}
					if ($Horizontal==1) {
						$MinX=$Placement[$i*4-1];
						$MinY=$Placement[$i*4];
						$MaxY=$MinY; $MaxX=$MinX;
						while (ord($Board[$MinX][$MinY-1])>=96) --$MinY;
						while (ord($Board[$MaxX][$MaxY+1])>=96) ++$MaxY;
					}
					$T=ScoreWord($Board,$MinX,$MinY,$MaxX,$MaxY);
					if ($T==-1) $AllGood=0; else $TotalScore+=$T;
				}
			}
		} 	
		if ($AllGood==1) $CurrentScore[$PlayersTurn]+=$TotalScore;
		return $AllGood;  // 1 if true, 0 If there was a problem.
	}

	function ToggleTurn() {
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$CurrentScore,$Placement,$Racks,$Tiles;
		if ($PlayersTurn==1) $PlayersTurn=2; else $PlayersTurn=1;
		$Throws=3;
	}

	function CheckWinner($Board) { //Returns 0=no winner; 1=1stplayer; 2=2nd player
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$CurrentScore,$Placement,$Racks,$Tiles;
		$Found=0;
		++$PlayerScore[$CurrentWinner];
	}

//////////////////////////////////////////[ BEGIN GAME ]/////////////////////////////////
Setup($USERNAME,$OPPONENT);
srand(time());
if (file_exists("data/$Player[1]-$Player[2].crossword")) {
	$Board=LoadData();
} else {
	$Board=ResetData();
	WriteData($Board);
};

if ($HELP==1) {
	require("help/crossword.help");
	exit();
}

if ($CHOOSETILE==1) {
	$i=29;
	while (($Placement[$i]==0)&&($i>=1)) --$i;
	$NumberPlayed=floor($i/4);
	$Placement[$NumberPlayed*4+2]=$TILE;
	WriteData($Board);
}
if ($PLACETILE==1) {
	$i=29;
	while (($Placement[$i]==0)&&($i>=1)) --$i;
	$NumberPlayed=floor($i/4);
	$Placement[$NumberPlayed*4+3]=$X;
	$Placement[$NumberPlayed*4+4]=$Y;
	WriteData($Board);
}
if ($DONE==1) {
	include("dictionary.inc");  // Hasbro Online dictionary checker
	if (ComputeScore($Board)) {
		$i=29;
		while (($Placement[$i]==0)&&($i>=1)) --$i;
		$NumberPlayed=floor($i/4);
		for ($i=1; $i<=$NumberPlayed; $i++) {
			$Board[$Placement[$i*4-1]][$Placement[$i*4]]=$Racks[$Placement[$i*4-2]];
			ChooseTile(1,$Placement[$i*4-2],0);
		}
		ToggleTurn();
		for ($i=1; $i<=29; $i++) $Placement[$i]=0;
		WriteData($Board);
	} else {
		print "<FONT COLOR=RED><B><CENTER>NOT A VALID WORD or PLACEMENT IS ILLEGAL</CENTER></B></FONT><BR>";
		for ($i=1; $i<=29; $i++) $Placement[$i]=0;
		WriteData($Board);		
	}
}

if ($RESET==1) {
	if ($CurrentScore[1]>$CurrentScore[2]) ++$PlayerScore[1]; else ++$PlayerScore[2]; //when game is reset, high scorer wins
	if ($CurrentScore[1]==$CurrentScore[2]) ++$PlayerScore[1];  //tie game (both score 1)
	$Board=ResetData();
	WriteData($Board);
}


if ($NEWTILES==1) {
	if ($Player[$PlayersTurn]==$USERNAME) {
		if (isset($CHECK1)) ChooseTile($PlayersTurn,1,1);
		if (isset($CHECK2)) ChooseTile($PlayersTurn,2,1);
		if (isset($CHECK3)) ChooseTile($PlayersTurn,3,1);
		if (isset($CHECK4)) ChooseTile($PlayersTurn,4,1);
		if (isset($CHECK5)) ChooseTile($PlayersTurn,5,1);
		if (isset($CHECK6)) ChooseTile($PlayersTurn,6,1);
		if (isset($CHECK7)) ChooseTile($PlayersTurn,7,1);
		ToggleTurn();
		WriteData($Board);
	}
}



include("managecurrentusers.inc");
if (GetPartner($OPPONENT)!=$USERNAME) {
	print("<HTML><CENTER><FONT SIZE=+2 COLOR=RED>$OPPONENT Has Closed The Game.<BR>To Exit, Click ");
	print ("<A HREF=\"welcome.php?USERNAME=$USERNAME&CODE=$CODE&CLOSE=1\" TARGET=LEFT>HERE</A>.</HTML>");
	exit();
}       

if (($Player[$PlayersTurn]==$USERNAME)&&($CurrentWinner==0)) $MyTurn=1; Else $MyTurn=0;

$BoardLinks=0;
$i=29; $Status="You have used all pieces, Click <A HREF=\"crossword.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&DONE=1\">Done</A>";
while (($Placement[$i]==0)&&($i>=1)) --$i;
if ($i==1) $Status="Choose a piece to place, or pick new pieces";
if ($i%4==2) { $BoardLinks=1; $Status="Now click where to place piece"; };
if ($i%4==0) $Status="Choose Another Piece, Or Click <A HREF=\"crossword.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&DONE=1\">Done</A>";
$NumberPlayed=floor($i/4);


////////////////////////////[ BEGIN DISPLAYING WEB PAGE ]

print "<HTML><HEAD>";
if ($MyTurn==1) $Refresh=60; else $Refresh=15;
print("<meta http-equiv=\"refresh\" content=\"$Refresh;URL=crossword.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE\">");
print "</HEAD><BODY BGCOLOR=FFFFFF HLINK=BLUE VLINK=BLUE ALINK=BLUE>
	<CENTER><FONT SIZE=+2 COLOR=BLUE>CROSSWORD</FONT><BR>
	$Player[1] vs. $Player[2]<BR></FONT><FONT SIZE=+1><B> - ";
if ($CurrentWinner==0) print ("$Player[$PlayersTurn]'s turn (player $PlayersTurn)</FONT>"); 
else print ("<FONT COLOR=RED SIZE=+2>$Player[$CurrentWinner] wins the game!</FONT>");
print " -</B>";
print "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>";
for ($i=1; $i<=15; $i++) {
	print "<TR>";
	for ($j=1; $j<=15; $j++) {
		$Link=0;
		if (($BoardLinks==1)&&($MyTurn==1)&&(ord($Board[$j][$i])<96)) { //a number
			if ($NumberPlayed==0) $Link=1;
			if ($NumberPlayed==1) {
				if ($Placement[3]==$j) $Link=1;
				if ($Placement[4]==$i) $Link=1;		
			}
			if ($NumberPlayed>=2) {
				if (($Placement[3]==$Placement[7])&&($Placement[7]==$j)) $Link=1;
				if (($Placement[4]==$Placement[8])&&($Placement[8]==$i)) $Link=1;
			}
		};
		print "<TD>";
		if ($Link==1) print "<A HREF=\"crossword.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&PLACETILE=1&X=$j&Y=$i\">";
		$ShowTile=0;
		for ($k=1; $k<=$NumberPlayed; $k++) if (($Placement[$k*4-1]==$j)&&($Placement[$k*4]==$i)) $ShowTile=$k;
		if ($ShowTile!=0) print "<IMG SRC=graphics/cross-{$Racks[$Placement[$ShowTile*4-2]]}.gif WIDTH=20 HIEGHT=20 BORDER=0>";
		else print "<IMG SRC=graphics/cross-{$Board[$j][$i]}.gif WIDTH=20 HIEGHT=20 BORDER=0>";
		if ($Link==1) print "</A>";
		print "</TD>";
	};
	print "</TR>";
};
print "</TABLE>";

if ($MyTurn==1) print "<FONT SIZE=-1>$Status</FONT>";

print "<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0>";
if ($MyTurn==1) print "<FORM ACTION=\"crossword.php\" METHOD=POST>
<INPUT TYPE=HIDDEN NAME=USERNAME VALUE=$USERNAME>
<INPUT TYPE=HIDDEN NAME=OPPONENT VALUE=$OPPONENT>
<INPUT TYPE=HIDDEN NAME=CODE VALUE=$CODE>
<INPUT TYPE=HIDDEN NAME=NEWTILES VALUE=1>";
print "<TR>";
if ($Player[2]==$USERNAME) $Offset=10; else $Offset=0;
for ($i=1+$Offset; $i<=7+$Offset; $i++) {
	print "<TD>";
	$ShowTile=1;
	for ($j=0; $j<=$NumberPlayed; $j++) if ($Placement[$j*4+2]==$i) $ShowTile=0;
	if (($ShowTile==1)&&($Racks[$i]!="0")) {
		if ($MyTurn==1) print "<A HREF=\"crossword.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&CHOOSETILE=1&TILE=$i\">";
		print "<IMG SRC=graphics/cross-$Racks[$i].gif WIDTH=20 HEIGHT=20 BORDER=0>";
		if ($MyTurn==1) print "</A>";
		if ($i>10) $j=$i-10; else $j=$i;
		if (($MyTurn==1)&&($NumberPlayed==0)) print "<BR><INPUT TYPE=CHECKBOX NAME=CHECK$j>";
	}
	print "</TD>";
}
if (($MyTurn==1)&&($NumberPlayed==0)) print "<TD><INPUT TYPE=SUBMIT VALUE=\"NEW TILES\"></TD></FORM>";
print "</TR></TABLE>
Current Score[ $Player[1]: $CurrentScore[1] / $Player[2]: $CurrentScore[2] ] ";
$j=0;
for ($i=1; $i<=27; $i++) $j+=$Tiles[$i];
print " ($j tiles left)
<BR>
<A HREF=\"welcome.php?USERNAME=$USERNAME&CODE=$CODE&CLOSE=1\" TARGET=LEFT>CLOSE GAME</A> - 
<A HREF=\"crossword.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&RESET=1\">NEW GAME</A> - 
<A HREF=\"crossword.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&HELP=1\">HELP</A>
<BR></FONT>OVERALL SCORE:  
1st Player $Player[1] $PlayerScore[1] games; 2nd Player $Player[2] $PlayerScore[2] games
<BR></CENTER></BODY></HTML>"; 

?>
