<?
//////////////////////////////////////////////////////////////////////
////
////  MAHC - MAHC Advanced Html Chat Version 1.0.0
////  Complex Chat System Written in PHP4 Supporting HTML-only clients
////  Copyright (C) 2001 Joseph Durbin <jdurbin@users.sourceforge.net>
////  This Source is GNU GPL, See file LICENSE in distribution.
////
//////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// PROGRAM NAME: dicezee.php
// AUTHOR: Joe Durbin
// DESCRIPTION: Web-based, 2 player dicezee Game, Component for MAHC
// FILES & DESCRIPTIONS:
//   dicezee.php  - PHP4 Main Program File ($USERNAME & $OPPONENT are only external variables needed)
//   help/dicezee.help - PHP4 Help Text for Program
//   data/$user-$user.dicezee - Custom Data File For Current Game Data Between 2 Users
//
// DATE: 11/17/2000 dicezee.php VERSION: 1.0 CHANGES: First Version
//
////////////////////////////////////////////////////////////////  
	//// Verify Current Session ID Code. (prevent Hijacking of ID!)
	include("verifysessioncode.inc");
	VerifySessionCode($USERNAME,$CODE);

	function Setup($username,$opponent) {
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Die,$Throws;
		if ($username<$opponent) {
			$Player[1]=$username;  //1st
			$Player[2]=$opponent;  //2nd
		} else {
			$Player[1]=$opponent;  //1st
			$Player[2]=$username;  //2nd
		};	
		$PlayersTurn=1;
		$PlayerScore[1]=0;  //1st
		$PlayerScore[2]=0;  //2nd
	}

	function ResetData() {  //Reset gameboard data and switch playersturn to opposite that started last game.
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Die,$Throws;
		for ($i=1; $i<=14; $i++)
			for ($j=1; $j<=2; $j++) $Board[$i][$j]=""; 
		if ($PlayerWhoStartedGame==1) $PlayerWhoStartedGame=2; else $PlayerWhoStartedGame=1;
		$PlayersTurn=$PlayerWhoStartedGame; 
		$GameInPlay=1;
		$CurrentWinner=0;
		$Throws=3;
		return $Board;
	}
	function WriteData($Board) {   //write game data file
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Die,$Throws;
		$DataFile=fopen("data/$Player[1]-$Player[2].dicezee","w");
		if (!($DataFile)) die("Could not open Game Data File!!!");
		fputs($DataFile,"$GameInPlay:$PlayersTurn:$PlayerScore[1]:$PlayerScore[2]:$PlayerWhoStartedGame:$CurrentWinner:\n");
		fputs($DataFile,"$Die[1]:$Die[2]:$Die[3]:$Die[4]:$Die[5]:$Throws:\n");
		for ($j=1; $j<=2; $j++) {
			for ($i=1; $i<=14; $i++) fputs($DataFile,"{$Board[$i][$j]}:");
			fputs($DataFile,"\n");
		}
		fclose($DataFile);
	}
	function LoadData() {   //read game data file
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Die,$Throws;
		$DataFile=fopen("data/$Player[1]-$Player[2].dicezee","r");
		if (!($DataFile)) die("Could not openGame Data File!!!");
		$Line		=	fgetcsv($DataFile,255,":");
		$GameInPlay	=	$Line[0];
		$PlayersTurn	=	$Line[1];
		$PlayerScore[1]	=	$Line[2];
		$PlayerScore[2]	=	$Line[3];
		$PlayerWhoStartedGame=	$Line[4];
		$CurrentWinner	=	$Line[5];
		$Line		=	fgetcsv($DataFile,255,":");
		$Die[1]		=	$Line[0];
		$Die[2]		=	$Line[1];
		$Die[3]		=	$Line[2];
		$Die[4]		=	$Line[3];
		$Die[5]		=	$Line[4];
		$Throws		=	$Line[5];
		for ($j=1; $j<=2; $j++) {
			$Line=fgetcsv($DataFile,255,":");
			for ($i=1; $i<=14; $i++) {
				$Board[$i][$j]=$Line[$i-1];
			}
		}
		fclose($DataFile);
		return $Board;
	}
	
	function Roll($D1,$D2,$D3,$D4,$D5) {
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Die,$Throws;
		srand(time());
		$D[1]=$D1; $D[2]=$D2; $D[3]=$D3; $D[4]=$D4; $D[5]=$D5;
		if ($Throws==3) {
			for ($i=1; $i<=5; ++$i) $Die[$i]=rand(1,6);
		} else {
			for ($i=1; $i<=5; ++$i) if ($D[$i]==1) $Die[$i]=rand(1,6);
		}
		if (($D[1]+$D[2]+$D[3]+$D[4]+$D[5]>=1)||($Throws==3)) --$Throws; //only decrement if they actually selected dice to re-roll!
	}
	function ComputeScore($Method) {
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Die,$Throws;
		$Di2=$Die; $Di2[0]=0;
		sort($Di2);
		$Score=0;
		switch($Method) {
			case(1): //ones
				for ($i=1; $i<=5; ++$i) if ($Die[$i]==1) $Score+=1;
				break;
			case(2): //twos
				for ($i=1; $i<=5; ++$i) if ($Die[$i]==2) $Score+=2;
				break;
			case(3): //threes
				for ($i=1; $i<=5; ++$i) if ($Die[$i]==3) $Score+=3;
				break;
			case(4): //fours
				for ($i=1; $i<=5; ++$i) if ($Die[$i]==4) $Score+=4;
				break;
			case(5):  //fives
				for ($i=1; $i<=5; ++$i) if ($Die[$i]==5) $Score+=5;
				break;
			case(6): // sixes
				for ($i=1; $i<=5; ++$i) if ($Die[$i]==6) $Score+=6;
				break;
			case(7): //bonus
			case(8): //3 of a kind
				if ($Di2[1]==$Di2[3]) for ($i=1; $i<=5; ++$i) $Score+=$Di2[$i];
				else if ($Di2[2]==$Di2[4]) for ($i=1; $i<=5; ++$i) $Score+=$Di2[$i];
				else if ($Di2[3]==$Di2[5]) for ($i=1; $i<=5; ++$i) $Score+=$Di2[$i];
				break;
			case(9): //4 of a kind
				if ($Di2[1]==$Di2[4]) for ($i=1; $i<=5; ++$i) $Score+=$Di2[$i];
				else if ($Di2[2]==$Di2[5]) for ($i=1; $i<=5; ++$i) $Score+=$Di2[$i];
				break;
			case(10): //fullhouse
				if (($Di2[1]==$Di2[3])&&($Di2[4]==$Di2[5])) $Score=25;
				if (($Di2[1]==$Di2[2])&&($Di2[3]==$Di2[5])) $Score=25;
				break;
			case(11): //4 straight
				if (($Di2[4]==$Di2[5]-1)&&($Di2[3]==$Di2[4]-1)&&($Di2[2]==$Di2[3]-1)) $Score=30;
				if (($Di2[1]==$Di2[2]-1)&&($Di2[3]==$Di2[4]-1)&&($Di2[2]==$Di2[3]-1)) $Score=30;
				if (($Di2[1]==$Di2[2]-1)&&($Di2[2]==$Di2[3]-1)&&($Di2[3]==$Di2[4])&&($Di2[4]==$Di2[5]-1)) $Score=30;
				if (($Di2[1]==$Di2[2]-1)&&($Di2[2]==$Di2[3])&&($Di2[3]==$Di2[4]-1)&&($Di2[4]==$Di2[5]-1)) $Score=30;
				break;
			case(12): //5 straight
				if (($Di2[4]==$Di2[5]-1)&&($Di2[3]==$Di2[4]-1)&&($Di2[2]==$Di2[3]-1)&&($Di2[1]==$Di2[2]-1)) $Score=40;
				break;
			case(13): // chance
				for ($i=1; $i<=5; ++$i) $Score+=$Di2[$i];
				break;
			case(14): //dicezee
				if ($Di2[1]==$Di2[5]) $Score=50;
				break;
		}
		return $Score;				
	}

	function ToggleTurn() {
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Die,$Throws;
		if ($PlayersTurn==1) $PlayersTurn=2; else $PlayersTurn=1;
		$Throws=3;
	}
	
	function TotalScores($Board) {
		global $P1Total,$P2Total;
		$P1Total=0; $P2Total=0;
		for ($i=1; $i<=6; ++$i) {
			$P1Total+=$Board[$i][1];
			$P2Total+=$Board[$i][2];
		}
		$Board[7][1]=0; $Board[7][2]=0;
		if ($P1Total>=63) $Board[7][1]=35;
		if ($P2Total>=63) $Board[7][2]=35;
		for ($i=7; $i<=14; ++$i) {
			$P1Total+=$Board[$i][1];
			$P2Total+=$Board[$i][2];
		}
		return $Board;
	}

	function CheckWinner($Board) { //Returns 0=no winner; 1=1stplayer; 2=2nd player
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Die,$Throws,$P1Total,$P2Total;
		$Found=0;
		for ($i=1; $i<=14; $i++) {  //check to see that all methods have been played
			if ((string)$Board[$i][1]=="") $Found=1;
			if ((string)$Board[$i][2]=="") $Found=1;
		}
		if ($Found==0) {
			if ($P1Total>=$P2Total) $CurrentWinner=1; else $CurrentWinner=2;
		}
		++$PlayerScore[$CurrentWinner];
	}

//////////////////////////////////////////[ BEGIN GAME ]/////////////////////////////////
Setup($USERNAME,$OPPONENT);

if (file_exists("data/$Player[1]-$Player[2].dicezee")) {
	$Board=LoadData();
} else {
	Roll(1,1,1,1,1);  
	$Board=ResetData();
	WriteData($Board);
};

if ($HELP==1) {
	require("help/dicezee.help");
	exit();
}

if ($RESET==1) {
	Roll(1,1,1,1,1);
	$Board=ResetData();
	WriteData($Board);
}

if ($ROLL==1) {
	if ($Player[$PlayersTurn]==$USERNAME) {
		if ($Throws>=1) {
			Roll($DIE1,$DIE2,$DIE3,$DIE4,$DIE5);
			WriteData($Board);
		}
	}
}


if (($SCORE!=0)&&($Throws<=2)&&((string)$Board[$SCORE][$PlayersTurn]=="")) {
	$Board[$SCORE][$PlayersTurn]=ComputeScore($SCORE);
	ToggleTurn();
	$Board=TotalScores($Board);
	CheckWinner($Board);
	WriteData($Board);
}

include("managecurrentusers.inc");
if (GetPartner($OPPONENT)!=$USERNAME) {
	print("<HTML><CENTER><FONT SIZE=+2 COLOR=RED>$OPPONENT Has Closed The Game.<BR>To Exit, Click ");
	print ("<A HREF=\"welcome.php?USERNAME=$USERNAME&CODE=$CODE&CLOSE=1\" TARGET=LEFT>HERE</A>.</HTML>");
	exit();
}       

$Board=TotalScores($Board); // Compute the total scores for each player

if (($Player[$PlayersTurn]==$USERNAME)&&($CurrentWinner==0)) $MyTurn=1; Else $MyTurn=0;
?>

<HTML><HEAD>
<? 
	if ($MyTurn==1) $Refresh=45; else $Refresh=5;
	print("<meta http-equiv=\"refresh\" content=\"$Refresh;URL=dicezee.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE\">");
?>
</HEAD><BODY BGCOLOR=FFFFFF HLINK=BLUE VLINK=BLUE ALINK=BLUE>
<CENTER><FONT SIZE=+2 COLOR=BLUE>DICEZEE</FONT><BR>
<? print("$Player[1] vs. $Player[2]"); ?>
<BR></FONT>
<FONT SIZE=+1><B>
- <? 
if ($CurrentWinner==0) print ("$Player[$PlayersTurn]'s turn (player $PlayersTurn)"); 
else print ("<FONT COLOR=RED SIZE=+2>$Player[$CurrentWinner] wins the game!</FONT>");
?> -</B>
<? if (($MyTurn==1)&&($Throws<=2)) {
print "<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0>
<FORM ACTION=\"dicezee.php\" METHOD=POST>
<INPUT TYPE=HIDDEN NAME=ROLL VALUE=1>
<INPUT TYPE=HIDDEN NAME=USERNAME VALUE=$USERNAME>
<INPUT TYPE=HIDDEN NAME=OPPONENT VALUE=$OPPONENT>
<INPUT TYPE=HIDDEN NAME=CODE VALUE=$CODE>
<TR>
<TD><CENTER><FONT SIZE=+2><IMG SRC=graphics/dicez-$Die[1].jpg></FONT><BR><INPUT TYPE=CHECKBOX NAME=DIE1 VALUE=1></TD>
<TD><CENTER><FONT SIZE=+2><IMG SRC=graphics/dicez-$Die[2].jpg></FONT><BR><INPUT TYPE=CHECKBOX NAME=DIE2 VALUE=1></TD>
<TD><CENTER><FONT SIZE=+2><IMG SRC=graphics/dicez-$Die[3].jpg></FONT><BR><INPUT TYPE=CHECKBOX NAME=DIE3 VALUE=1></TD>
<TD><CENTER><FONT SIZE=+2><IMG SRC=graphics/dicez-$Die[4].jpg></FONT><BR><INPUT TYPE=CHECKBOX NAME=DIE4 VALUE=1></TD>
<TD><CENTER><FONT SIZE=+2><IMG SRC=graphics/dicez-$Die[5].jpg></FONT><BR><INPUT TYPE=CHECKBOX NAME=DIE5 VALUE=1></TD>
<TD BGCOLOR=DDDDDD><CENTER><B>$Throws Rolls Left</B><BR><INPUT TYPE=SUBMIT VALUE=";
print "REROLL></TD>
</TR>
</FORM>
<FORM ACTION=\"dicezee.php\" METHOD=POST>
<INPUT TYPE=HIDDEN NAME=USERNAME VALUE=$USERNAME>
<INPUT TYPE=HIDDEN NAME=OPPONENT VALUE=$OPPONENT>
<INPUT TYPE=HIDDEN NAME=CODE VALUE=$CODE>
<TR>
<TD COLSPAN=6 BGCOLOR=EEEEEE><B>SELECT:</B><SELECT NAME=SCORE>
<OPTION VALUE=1 >Ones [".ComputeScore(1)."]
<OPTION VALUE=2 >Twos [".ComputeScore(2)."]
<OPTION VALUE=3 >Threes [".ComputeScore(3)."]
<OPTION VALUE=4 >Fours [".ComputeScore(4)."]
<OPTION VALUE=5 >Fives [".ComputeScore(5)."]
<OPTION VALUE=6 >Sixes [".ComputeScore(6)."]
<OPTION VALUE=8 >3 of a Kind [".ComputeScore(8)."]
<OPTION VALUE=9 >4 of a Kind [".ComputeScore(9)."]
<OPTION VALUE=10>Full House [".ComputeScore(10)."]
<OPTION VALUE=11>4 Straight [".ComputeScore(11)."]
<OPTION VALUE=12>5 Straight [".ComputeScore(12)."]
<OPTION VALUE=13>Chance [".ComputeScore(13)."]
<OPTION VALUE=14>Dicezee [".ComputeScore(14)."]
</SELECT> &nbsp; <INPUT TYPE=SUBMIT VALUE=SCORE></TD>
</TR></FORM></TABLE>";
} else { print "
<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0>";
if ($MyTurn==1) print "<FORM ACTION=\"dicezee.php\" METHOD=POST>
<INPUT TYPE=HIDDEN NAME=ROLL VALUE=1>
<INPUT TYPE=HIDDEN NAME=USERNAME VALUE=$USERNAME>
<INPUT TYPE=HIDDEN NAME=CODE VALUE=$CODE>
<INPUT TYPE=HIDDEN NAME=OPPONENT VALUE=$OPPONENT>";
print "<TR>
<TD><CENTER><FONT SIZE=+2><IMG SRC=graphics/dicez-$Die[1].jpg></FONT></TD>
<TD><CENTER><FONT SIZE=+2><IMG SRC=graphics/dicez-$Die[2].jpg></FONT></TD>
<TD><CENTER><FONT SIZE=+2><IMG SRC=graphics/dicez-$Die[3].jpg></FONT></TD>
<TD><CENTER><FONT SIZE=+2><IMG SRC=graphics/dicez-$Die[4].jpg></FONT></TD>
<TD><CENTER><FONT SIZE=+2><IMG SRC=graphics/dicez-$Die[5].jpg></FONT></TD>
<TD BGCOLOR=DDDDDD><CENTER><B>$Throws Rolls Left<BR>";
if ($MyTurn==1) print "<INPUT TYPE=SUBMIT VALUE=ROLL></FORM>";
print "</B></TD></TR></TABLE>";
}
?>

<BR>

<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 BGCOLOR=fef2ae>
<TR><TD COLSPAN=6><B><CENTER>CURRENT SCORE PAD</TD></TR>
<TR BGCOLOR=EEE3A4><TD>&nbsp;</TD><TD BGCOLOR=D0D0D0>1st</TD><TD BGCOLOR=E0E0E0>2nd</TD><TD>&nbsp;</TD><TD BGCOLOR=D0D0D0>1st</TD><TD BGCOLOR=E0E0E0>2nd</TD></TR>
<TR><TD>Ones  </TD><TD BGCOLOR=DDDDDD>&nbsp;<? print $Board[1][1]; ?></TD><TD BGCOLOR=EEEEEE>&nbsp;<? print $Board[1][2]; ?></TD><TD>3 of a Kind  </TD><TD BGCOLOR=DDDDDD>&nbsp;<? print $Board[8][1]; ?></TD><TD BGCOLOR=EEEEEE>&nbsp;<? print $Board[8][2]; ?></TD></TR>
<TR><TD>Twos  </TD><TD BGCOLOR=DDDDDD>&nbsp;<? print $Board[2][1]; ?></TD><TD BGCOLOR=EEEEEE>&nbsp;<? print $Board[2][2]; ?></TD><TD>4 of a Kind  </TD><TD BGCOLOR=DDDDDD>&nbsp;<? print $Board[9][1]; ?></TD><TD BGCOLOR=EEEEEE>&nbsp;<? print $Board[9][2]; ?></TD></TR>
<TR><TD>Threes</TD><TD BGCOLOR=DDDDDD>&nbsp;<? print $Board[3][1]; ?></TD><TD BGCOLOR=EEEEEE>&nbsp;<? print $Board[3][2]; ?></TD><TD>Full House   </TD><TD BGCOLOR=DDDDDD>&nbsp;<? print $Board[10][1]; ?></TD><TD BGCOLOR=EEEEEE>&nbsp;<? print $Board[10][2]; ?></TD></TR>
<TR><TD>Fours </TD><TD BGCOLOR=DDDDDD>&nbsp;<? print $Board[4][1]; ?></TD><TD BGCOLOR=EEEEEE>&nbsp;<? print $Board[4][2]; ?></TD><TD>4 Straight </TD><TD BGCOLOR=DDDDDD>&nbsp;<? print $Board[11][1]; ?></TD><TD BGCOLOR=EEEEEE>&nbsp;<? print $Board[11][2]; ?></TD></TR>
<TR><TD>Fives </TD><TD BGCOLOR=DDDDDD>&nbsp;<? print $Board[5][1]; ?></TD><TD BGCOLOR=EEEEEE>&nbsp;<? print $Board[5][2]; ?></TD><TD>5 Straight</TD><TD BGCOLOR=DDDDDD>&nbsp;<? print $Board[12][1]; ?></TD><TD BGCOLOR=EEEEEE>&nbsp;<? print $Board[12][2]; ?></TD></TR>
<TR><TD>Sixes </TD><TD BGCOLOR=DDDDDD>&nbsp;<? print $Board[6][1]; ?></TD><TD BGCOLOR=EEEEEE>&nbsp;<? print $Board[6][2]; ?></TD><TD>Chance       </TD><TD BGCOLOR=DDDDDD>&nbsp;<? print $Board[13][1]; ?></TD><TD BGCOLOR=EEEEEE>&nbsp;<? print $Board[13][2]; ?></TD></TR>
<TR><TD>Bonus </TD><TD BGCOLOR=DDDDDD>&nbsp;<? print $Board[7][1]; ?></TD><TD BGCOLOR=EEEEEE>&nbsp;<? print $Board[7][2]; ?></TD><TD>Dicezee     </TD><TD BGCOLOR=DDDDDD>&nbsp;<? print $Board[14][1]; ?></TD><TD BGCOLOR=EEEEEE>&nbsp;<? print $Board[14][2]; ?></TD></TR>
<TR BGCOLOR=CC0000><TD COLSPAN=3>&nbsp      </TD><TD><B><FONT COLOR=FFFFFF>TOTAL:    </TD><TD BGCOLOR=D0D0D0>&nbsp;<? print $P1Total; ?></TD><TD BGCOLOR=E0E0E0>&nbsp;<? print $P2Total; ?></TD></TR>
</TABLE>

<BR>
<? print ("<A HREF=\"welcome.php?USERNAME=$USERNAME&CODE=$CODE&CLOSE=1\" TARGET=LEFT>"); ?>
CLOSE GAME</A> - 
<? print ("<A HREF=\"dicezee.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&RESET=1\">"); ?>
NEW GAME</A> - 
<? print ("<A HREF=\"dicezee.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&HELP=1\">"); ?>
HELP</A>
<BR></FONT>
OVERALL SCORE:  
<? print("1st Player $Player[1] $PlayerScore[1] games; 2nd Player $Player[2] $PlayerScore[2] games"); ?>
<BR>

</CENTER></BODY></HTML>

