<?
//////////////////////////////////////////////////////////////////////
////
////  MAHC - MAHC Advanced Html Chat Version 1.0.0
////  Complex Chat System Written in PHP4 Supporting HTML-only clients
////  Copyright (C) 2001 Joseph Durbin <jdurbin@users.sourceforge.net>
////  This Source is GNU GPL, See file LICENSE in distribution.
////
//////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// PROGRAM NAME: hangman.php
// AUTHOR: Joe Durbin
// DESCRIPTION: Web-based, 2 player Hangman Game Component for MAHC
// FILES & DESCRIPTIONS:
//   hangman.php  - PHP4 Main Program File ($USERNAME & $OPPONENT are only external variables needed)
//   help/hangman.help - PHP4 Help Text for Program
//   hangman.dict - words to use for hangman, 1 word per line text file
//   data/$user-$user.hangman - Custom Data File For Current Game Data Between 2 Users
//
// DATE: 11/17/2000 hangman.php VERSION: 1.0 CHANGES: First Version
//
////////////////////////////////////////////////////////////////  
	//// Verify Corrent Session ID Code. (prevent Hijacking of ID!)
	include("verifysessioncode.inc");
	VerifySessionCode($USERNAME,$CODE); 

	function Setup($username,$opponent) {
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Mode,$Word,$PlayerHung;
		if ($username<$opponent) {
			$Player[1]=$username; 
			$Player[2]=$opponent;
		} else {
			$Player[1]=$opponent; 
			$Player[2]=$username; 
		};	
		$PlayersTurn=1;
		$PlayerScore[1]=0; 
		$PlayerScore[2]=0; 
	}

	function ResetData() {  //Reset gameboard data and switch playersturn to opposite that started last game.
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Mode,$Word,$PlayerHung;
		for ($i=0; $i<=27; $i++) $Letters[$i]=0; 
		if ($PlayerWhoStartedGame==1) $PlayerWhoStartedGame=2; else $PlayerWhoStartedGame=1;
		$PlayersTurn=$PlayerWhoStartedGame; 
		$Word="SUPERMAN";
		$Dict=fopen("hangman.dict","r");
		if (!($Dict)) die("Could not open Game Dictionary File!!!");
		$i=0;
		while (!feof($Dict)) {
			$Line=fgetcsv($Dict,255,"\n");
			$Dictionary[$i]=$Line[0];
			++$i;
		}
		fclose($Dict);
		srand(time());
		$Word=$Dictionary[rand(0,$i-1)];
		$Word=strtoupper($Word);
		$GameInPlay=1;
		$CurrentWinner=0;
		$Mode=1;
		$PlayerHung[1]=0;
		$PlayerHung[2]=0;
		return $Letters;
	}
	function WriteData($Letters) {   //write game data file
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Mode,$Word,$PlayerHung;
		$DataFile=fopen("data/$Player[1]-$Player[2].hangman","w");
		if (!($DataFile)) die("Could not open Game Data File!!!");
		fputs($DataFile,"$GameInPlay:$PlayersTurn:$PlayerScore[1]:$PlayerScore[2]:$PlayerWhoStartedGame:$CurrentWinner:$Mode:$Word:$PlayerHung[1]:$PlayerHung[2]\n");
		for ($i=0; $i<=27; $i++) fputs($DataFile,"$Letters[$i]:");
		fputs($DataFile,"\n");
		fclose($DataFile);
	}
	function LoadData() {   //read game data file
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Mode,$Word,$PlayerHung;
		$DataFile=fopen("data/$Player[1]-$Player[2].hangman","r");
		if (!($DataFile)) die("Could not openGame Data File!!!");
		$Line		=	fgetcsv($DataFile,255,":");
		$GameInPlay	=	$Line[0];
		$PlayersTurn	=	$Line[1];
		$PlayerScore[1]	=	$Line[2];
		$PlayerScore[2]	=	$Line[3];
		$PlayerWhoStartedGame=	$Line[4];
		$CurrentWinner	=	$Line[5];
		$Mode		=	$Line[6];
		$Word		=	$Line[7];
		$PlayerHung[1]	=	$Line[8];
		$PlayerHung[2]	=	$Line[9];
		$Letters	=	fgetcsv($DataFile,255,":");
		fclose($DataFile);
		return $Letters;
	}
	
	function PickLetter($Letters, $x) {  // choose letter
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Mode,$Word,$PlayerHung;
		if ($Mode==1) {
			for ($i=0; $i<strlen($Word); $i++) {
				$Character=substr($Word,$i,1);
				$Index=ord($Character)-65;
				if ($Index==$x) $Letters[$x]=1;
			}; 
			if ($Letters[$x]!=1) ++$PlayerHung[$PlayersTurn];
			$Letters[$x]=1;
			$Mode=2;
		};
		return $Letters;
	}

	function ToggleTurn() {
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner,$Mode,$Word,$PlayerHung;
		if ($PlayersTurn==1) $PlayersTurn=2; else $PlayersTurn=1;
		$Mode=1;
	}

//////////////////////////////////////////[ BEGIN GAME ]/////////////////////////////////
Setup($USERNAME,$OPPONENT);

if (file_exists("data/$Player[1]-$Player[2].hangman")) {
	$Letters=LoadData();
} else {
	$Letters=ResetData();
	WriteData($Letters);
};	

if ($RESET==1) {
	$Letters=ResetData();
	WriteData($Letters);
}

include("managecurrentusers.inc");
if (GetPartner($OPPONENT)!=$USERNAME) {
	print("<HTML><CENTER><FONT SIZE=+2 COLOR=RED>$OPPONENT Has Closed The Game.<BR>To Exit, Click ");
	print ("<A HREF=\"welcome.php?USERNAME=$USERNAME&CODE=$CODE&CLOSE=1\" TARGET=LEFT>HERE</A>.</HTML>");
	exit();
}    

if ($HELP==1) {
	require("help/hangman.help");
	exit();
}  

if ((isset($X))&&($Player[$PlayersTurn]==$USERNAME)) {
	$Letters=PickLetter($Letters,$X);
	WriteData($Letters);
};
if (($LASTMOVE!="")&&($Player[$PlayersTurn]==$USERNAME)) {
	$SOLVE=strtoupper($SOLVE);
	if ($Word==$SOLVE) $CurrentWinner=$PlayersTurn;
	++$PlayerScore[$CurrentWinner];
	if ($CurrentWinner!=0) for ($i=0; $i<26; ++$i) $Letters[$i]=1;
	ToggleTurn();
	WriteData($Letters);
};

if ($Player[$PlayersTurn]==$USERNAME) $MyTurn=1; Else $MyTurn=0;
?>

<HTML><HEAD>
<? 
	if ($MyTurn==1) $Refresh=15; else $Refresh=7;
	if (($Mode==1)||($MyTurn==0)) print("<meta http-equiv=\"refresh\" content=\"$Refresh;URL=hangman.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE\">");
	else  print("<meta http-equiv=\"refresh\" content=\"20;URL=hangman.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&LASTMOVE=1\">");
?>
</HEAD><BODY BGCOLOR=FFFFFF VLINK=BLUE HLINK=BLUE ALINK=BLUE>
<CENTER>
<B><FONT SIZE=+2 COLOR=BLUE>HANGMAN<BR>
<? print("$Player[1] vs. $Player[2]"); ?>
<BR></FONT>
<FONT SIZE=+1>
- <? 
if ($CurrentWinner==0) print ("$Player[$PlayersTurn]'s turn"); 
else print ("<FONT COLOR=RED SIZE=+2>$Player[$CurrentWinner] wins the game!</FONT>");
?> - <BR>
<table cellpadding=10 cellspacing=1 border=1><TR>
<TD BGCOLOR=CCCCFF><FONT SIZE=+1><CENTER>
<? print("$Player[1]"); ?>
<BR><BR>
<? print("$PlayerHung[1]"); ?>
/7 Hung</TD>
<TD BGCOLOR=CCCCFF><FONT SIZE=+1><CENTER>
<? print("$Player[2]"); ?>
<BR><BR>
<? print("$PlayerHung[2]"); ?>
/7 Hung</TD>
</TR></TABLE>
<FONT SIZE=+1>

<?
	for ($i=0; $i<strlen($Word); $i++) {
		$Character=substr($Word,$i,1);
		$Index=ord($Character)-65;
		if ($Letters[$Index]==1) print "$Character "; else print "_ ";
	};
	
	print"<BR><BR>";

	for ($i=0; $i<26; $i++) { 
		if ($Letters[$i]==0) {
			if (($MyTurn==1)&&($Mode==1)) print ("<A HREF=\"hangman.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&X=$i\">");
			print chr($i+65);
			if (($MyTurn==1)&&($Mode==1)) print ("</A>");
		} else {
			//print chr($i+65);
			print (" ");
		};
	};

	if (($MyTurn==1)&&($Mode==2)) {
		print "<FORM ACTION=\"hangman.php\" METHOD=POST>";
		print "<INPUT TYPE=HIDDEN NAME=USERNAME VALUE=$USERNAME>";
		print "<INPUT TYPE=HIDDEN NAME=OPPONENT VALUE=$OPPONENT>";
		print "<INPUT TYPE=HIDDEN NAME=LASTMOVE VALUE=1>";
		print "<INPUT TYPE=HIDDEN NAME=CODE VALUE=$CODE>";
		print "Guess Word?:<INPUT TYPE=TEXT NAME=SOLVE> <INPUT TYPE=SUBMIT VALUE=\"END TURN\"></FORM>";
	};
?>
</FONT>
<BR><HR>
<A HREF="welcome.php?USERNAME=<? print"$USERNAME&CODE=$CODE"; ?>&CLOSE=1" TARGET=LEFT>
CLOSE GAME</A> - 
<? print ("<A HREF=\"hangman.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&RESET=1\">"); ?>
NEW GAME</A> -
<? print ("<A HREF=\"hangman.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&HELP=1\">"); ?>
HELP</A>

<BR></FONT>

OVERALL SCORE: <? print("$Player[1] $PlayerScore[1] games; $Player[2] $PlayerScore[2] games"); ?>

</BODY></HTML>
