<?
//////////////////////////////////////////////////////////////////////
////
////  MAHC - MAHC Advanced Html Chat Version 1.0.0
////  Complex Chat System Written in PHP4 Supporting HTML-only clients
////  Copyright (C) 2001 Joseph Durbin <jdurbin@users.sourceforge.net>
////  This Source is GNU GPL, See file LICENSE in distribution.
////
//////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// PROGRAM NAME: privatechat.php
// AUTHOR: Joe Durbin
// DESCRIPTION: Web-based, 2 person Private chat, Component for MAHC
// FILES & DESCRIPTIONS:
//   privatechat.php  - PHP4 Main Program File ($USERNAME & $OPPONENT are only external variables needed)
//   help/privatechat.help - PHP4 Help Text for Program
//   data/$user-$user.privatechat - Custom Data File For Current Game Data Between 2 Users
//
// DATE: 11/17/2000 privatechat.php VERSION: 1.0 CHANGES: First Version
//
////////////////////////////////////////////////////////////////  
	//// Verify Current Session ID Code. (prevent Hijacking of ID!)
	include("verifysessioncode.inc");
	include("prefs.inc");
	VerifySessionCode($USERNAME,$CODE);

	function Setup($username,$opponent) {
		global $Player;
		if ($username<$opponent) {
			$Player[1]=$username; 
			$Player[2]=$opponent;
		} else {
			$Player[1]=$opponent;
			$Player[2]=$username; 
		};	
	}

	function ResetData() {  //Reset privatechat data
		global $Player;
		for ($i=0; $i<=26; $i++) $Board[$i]=""; 
		return $Board;
	}
	function WriteData($Board,$username,$newtext) {   //write privatechat data file
		global $Player;
		include("chatsmilies.inc");
		$DataFile=fopen("data/$Player[1]-$Player[2].privatechat","w");
		if (!($DataFile)) die("Could not open PrivateChat Data File!!!");
		$newtext=stripcslashes($newtext);
		$newtext=ChatSmilies($newtext); 
		if ($Player[1]==$username) fputs($DataFile,"<FONT COLOR=BLACK><B>$username:</B> $newtext</FONT>\n");
		else fputs($DataFile,"<FONT COLOR=RED><B>$username:</B> $newtext</FONT>\n");
		for ($i=1; $i<=20; $i++) fputs($DataFile,"$Board[$i]"); 
		fclose($DataFile);
	}
	function LoadData() {   //read privatechat data file
		global $Player;
		$DataFile=fopen("data/$Player[1]-$Player[2].privatechat","r");
		if (!($DataFile)) die("Could not open Private chat Data File!!!");
		$i=1;
		while (!feof($DataFile)) { 
			$Board[$i]=fgets($DataFile,255);
			++$i;
		}
		fclose($DataFile);
		return $Board;
	}
	

//////////////////////////////////////////[ BEGIN GAME ]/////////////////////////////////
Setup($USERNAME,$OPPONENT);

if (file_exists("data/$Player[1]-$Player[2].privatechat")) {
	$Board=LoadData();
} else {
	$Board=ResetData();
};

if ($HELP==1) {
	require("help/privatechat.help");
	exit();
}

include("managecurrentusers.inc");
if (GetPartner($OPPONENT)!=$USERNAME) {
	print("<HTML><CENTER><FONT SIZE=+2 COLOR=RED>$OPPONENT Has Closed The Chat.<BR>To Exit, Click ");
	print ("<A HREF=\"welcome.php?USERNAME=$USERNAME&CODE=$CODE&CLOSE=1\" TARGET=LEFT>HERE</A>.</HTML>");
	exit();
}

if ($NEWTEXT!="") {
	WriteData($Board,$USERNAME,$NEWTEXT);
}

if ($RESET==1) {
	$NEWTEXT="Chat Room Text Cleared";
	$Board=ResetData();
	WriteData($Board,$USERNAME,$NEWTEXT);
}


	if ($BOTTOM==1) {
		print ("<HTML><HEAD>");
		print ("<meta http-equiv=\"refresh\" content=\"$REFRESHPRIVATECHAT;URL=privatechat.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&BOTTOM=1\">");
		print ("</HEAD><BODY BGCOLOR=$SHADOW2 HLINK=$HLINK VLINK=$VLINK ALINK=$ALINK MARGINHEIGHT=2 TOPMARGIN=2 >$FONT");
		for ($i=1; $i<=20; $i++) print ("$Board[$i]<BR>");
		print ("</HTML>");
	} else if ($TOP==1) {
		print ("<HTML><BODY BGCOLOR=$ACCENT2 MARGINHEIGHT=2 TOPMARGIN=2 HLINK=$HLINK VLINK=$VLINK ALINK=$ALINK>");
		print ("<CENTER><TABLE BGCOLOR=EEEEEE CELLPADDING=2 CELLSPACING=0 BORDER=1><FORM METHOD=POST ACTION=\"privatechat.php\">");
		print ("<TR><TD><CENTER><B><FONT SIZE=+1 COLOR=BLUE>PRIVATE CHAT</FONT><BR>");
		print (" (<FONT COLOR=BLACK>$Player[1]</FONT> with <FONT COLOR=RED>$Player[2]</FONT>)</B><BR>");
		print ("<INPUT TYPE=HIDDEN NAME=USERNAME VALUE=$USERNAME>");
		print ("<INPUT TYPE=HIDDEN NAME=CODE VALUE=$CODE>");
		print ("<INPUT TYPE=HIDDEN NAME=OPPONENT VALUE=$OPPONENT>");
		print ("<INPUT TYPE=HIDDEN NAME=TOP VALUE=1>");
		print ("<INPUT TYPE=TEXT NAME=NEWTEXT><INPUT TYPE=SUBMIT VALUE=SEND><BR>");
		print ("<A HREF=\"welcome.php?USERNAME=$USERNAME&CODE=$CODE&CLOSE=1\" TARGET=LEFT>CLOSE CHAT</A> - "); 
		print ("<A HREF=\"privatechat.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&RESET=1&TOP=1\">CLEAR CHAT</A> - ");
		print ("<A HREF=\"privatechat.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&HELP=1\" TARGET=LEFT>HELP</A>");
		print ("</TD></TR></FORM></TABLE></HTML>");
	} else {
		print ("<HTML><FRAMESET BORDER=1 ROWS=100,100% FRAMEBORDER=0 FRAMESPACING=1 SCROLLING=auto>");
		print ("<FRAME BORDER=0 FRAMEBORDER=0 NAME=PRIVTOP SCROLLING=no SRC=\"privatechat.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&TOP=1\">");
		print ("<FRAME BORDER=0 FRAMEBORDER=0 NAME=PRIVBOT
SCROLLING=auto
SRC=\"privatechat.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&BOTTOM=1\">");
		print ("</FRAMESET></HTML>");
		
	}
?>
