<?
//////////////////////////////////////////////////////////////////////
////
////  MAHC - MAHC Advanced Html Chat Version 1.0.0
////  Complex Chat System Written in PHP4 Supporting HTML-only clients
////  Copyright (C) 2001 Joseph Durbin <jdurbin@users.sourceforge.net>
////  This Source is GNU GPL, See file LICENSE in distribution.
////
//////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
// PROGRAM NAME: tictactoe.php
// AUTHOR: Joe Durbin
// DESCRIPTION: Web-based, 2 player TicTacToe Game, Component for MAHC
// FILES & DESCRIPTIONS:
//   tictactoe.php  - PHP4 Main Program File ($USERNAME & $OPPONENT are only external variables needed)
//   help/tictactoe.help - PHP4 Help Text for Program
//   data/$user-$user.tictactoe - Custom Data File For Current Game Data Between 2 Users
//
// DATE: 11/17/2000 tictactoe.php VERSION: 1.0 CHANGES: First Version
//
////////////////////////////////////////////////////////////////  
	//// Verify Corrent Session ID Code. (prevent Hijacking of ID!)
	include("verifysessioncode.inc");
	VerifySessionCode($USERNAME,$CODE);

	function Setup($username,$opponent) {
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner;
		if ($username<$opponent) {
			$Player[1]=$username;  //X
			$Player[2]=$opponent;  //O
		} else {
			$Player[1]=$opponent;  //X
			$Player[2]=$username;  //O
		};	
		$PlayersTurn=1;
		$PlayerScore[1]=0;  //X
		$PlayerScore[2]=0;  //O
	}

	function ResetData() {  //Reset gameboard data and switch playersturn to opposite that started last game.
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner;
		for ($i=1; $i<=3; $i++)
			for ($j=1; $j<=3; $j++) $Board[$i][$j]="?"; 
		if ($PlayerWhoStartedGame==1) $PlayerWhoStartedGame=2; else $PlayerWhoStartedGame=1;
		$PlayersTurn=$PlayerWhoStartedGame; 
		$GameInPlay=1;
		$CurrentWinner=0;
		return $Board;
	}
	function WriteData($Board) {   //write game data file
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner;
		$DataFile=fopen("data/$Player[1]-$Player[2].tictactoe","w");
		if (!($DataFile)) die("Could not open Game Data File!!!");
		fputs($DataFile,"$GameInPlay:$PlayersTurn:$PlayerScore[1]:$PlayerScore[2]:$PlayerWhoStartedGame:$CurrentWinner\n");
		fputs($DataFile,"{$Board[1][1]}:{$Board[2][1]}:{$Board[3][1]}\n");
		fputs($DataFile,"{$Board[1][2]}:{$Board[2][2]}:{$Board[3][2]}\n");
		fputs($DataFile,"{$Board[1][3]}:{$Board[2][3]}:{$Board[3][3]}\n");
		fclose($DataFile);
	}
	function LoadData() {   //read game data file
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner;
		$DataFile=fopen("data/$Player[1]-$Player[2].tictactoe","r");
		if (!($DataFile)) die("Could not openGame Data File!!!");
		$Line=fgetcsv($DataFile,255,":");
		$GameInPlay=$Line[0];
		$PlayersTurn=$Line[1];
		$PlayerScore[1]=$Line[2];
		$PlayerScore[2]=$Line[3];
		$PlayerWhoStartedGame=$Line[4];
		$CurrentWinner=$Line[5];
		for ($i=1; $i<=3; $i++) {
			$Line=fgetcsv($DataFile,255,":");
			for ($j=1; $j<=3; $j++) {
				$Board[$j][$i]=$Line[$j-1];
			}
		}
		fclose($DataFile);
		return $Board;
	}
	
	function PickPiece($Board, $x,$y) {  // choose game piece
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner;
		if ($Board[$x][$y]=="?") {
			if ($PlayersTurn==1) $Board[$x][$y]="X";
			if ($PlayersTurn==2) $Board[$x][$y]="O";
		}
		return $Board;
	}

	function ToggleTurn() {
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner;
		if ($PlayersTurn==1) $PlayersTurn=2; else $PlayersTurn=1;
	}

	function CheckWinner($Board) { //Returns 0=no winner; 1=1stplayer; 2=2nd player
		global $Player,$GameInPlay,$PlayersTurn,$PlayerScore,$PlayerWhoStartedGame,$CurrentWinner;
		for ($i=1; $i<=3; $i++) {  //straight line wins
			if (($Board[$i][1]=="X")&&($Board[$i][2]=="X")&&($Board[$i][3]=="X")) $CurrentWinner=1;
			if (($Board[$i][1]=="O")&&($Board[$i][2]=="O")&&($Board[$i][3]=="O")) $CurrentWinner=2;
			if (($Board[1][$i]=="X")&&($Board[2][$i]=="X")&&($Board[3][$i]=="X")) $CurrentWinner=1;
			if (($Board[1][$i]=="O")&&($Board[2][$i]=="O")&&($Board[3][$i]=="O")) $CurrentWinner=2;
		}
		// diagonal wins
		if (($Board[1][1]=="X")&&($Board[2][2]=="X")&&($Board[3][3]=="X")) $CurrentWinner=1;
		if (($Board[1][1]=="O")&&($Board[2][2]=="O")&&($Board[3][3]=="O")) $CurrentWinner=2;
		if (($Board[3][1]=="X")&&($Board[2][2]=="X")&&($Board[1][3]=="X")) $CurrentWinner=1;
		if (($Board[3][1]=="O")&&($Board[2][2]=="O")&&($Board[1][3]=="O")) $CurrentWinner=2;
		++$PlayerScore[$CurrentWinner];
	}

	function Background() {  // makes tiles checkered
		static $EveryOther;
		if ($EveryOther==0) {
			$EveryOther=1;
			$Back="l";
		} else {
			$EveryOther=0;
			$Back="d";
		};
		return $Back;
	}

	function DrawPiece($TYPE) {
		$IMAGE="<IMG WIDTH=75 HEIGHT=75 SRC=graphics/ticta-";
		$IMAGE.=Background();
		if ($TYPE=="?") $IMAGE.="b";
		if ($TYPE=="X") $IMAGE.="x";
		if ($TYPE=="O") $IMAGE.="o";
		$IMAGE.=".jpg BORDER=0>";
		return $IMAGE;
	}

//////////////////////////////////////////[ BEGIN GAME ]/////////////////////////////////
Setup($USERNAME,$OPPONENT);

if (file_exists("data/$Player[1]-$Player[2].tictactoe")) {
	$Board=LoadData();
} else {
	$Board=ResetData();
	WriteData($Board);
};

if ($HELP==1) {
	require("help/tictactoe.help");
	exit();
}

if ($RESET==1) {
	$Board=ResetData();
	WriteData($Board);
}

include("managecurrentusers.inc");
if (GetPartner($OPPONENT)!=$USERNAME) {
	print("<HTML><CENTER><FONT SIZE=+2 COLOR=RED>$OPPONENT Has Closed The Game.<BR>To Exit, Click ");
	print ("<A HREF=\"welcome.php?USERNAME=$USERNAME&CLOSE=1&CODE=$CODE\" TARGET=LEFT>HERE</A>.</HTML>");
	exit();
}       

if (($X>0)&&($Y>0)&&($Player[$PlayersTurn]==$USERNAME)) {
	$Board=PickPiece($Board,$X,$Y);
	CheckWinner($Board);
	ToggleTurn();
	WriteData($Board);
};

if ($Player[$PlayersTurn]==$USERNAME) $MyTurn=1; Else $MyTurn=0;
?>

<HTML><HEAD>
<? 
	if ($MyTurn==1) $Refresh=15; else $Refresh=6;
	print("<meta http-equiv=\"refresh\" content=\"$Refresh;URL=tictactoe.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE\">");
?>
</HEAD><BODY BGCOLOR=FFFFFF HLINK=BLUE VLINK=BLUE ALINK=BLUE>
<CENTER>
<B><FONT SIZE=+2 COLOR=BLUE>TIC-TAC-TOE<BR>
<? print("$Player[1] vs. $Player[2]"); ?>
<BR></FONT>
<FONT SIZE=+1>
- <? 
if ($CurrentWinner==0) print ("$Player[$PlayersTurn]'s turn"); 
else print ("<FONT COLOR=RED SIZE=+2>$Player[$CurrentWinner] wins the game!</FONT>");
?> -
<BR>
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
<TR><TD><IMG SRC=graphics/ticta-bord1.jpg></TD><TD><IMG SRC=graphics/ticta-bord2.jpg></TD><TD><IMG SRC=graphics/ticta-bord2.jpg></TD><TD><IMG SRC=graphics/ticta-bord2.jpg></TD><TD><IMG SRC=graphics/ticta-bord3.jpg></TD></TR>
<? 
for ($i=1; $i<=3; $i++) {
	print "<TR><TD><IMG SRC=graphics/ticta-bord4.jpg></TD>";
	for ($j=1; $j<=3; $j++) {
		print "<TD>";
		if (($MyTurn==1)&&($Board[$j][$i]=="?")) {
			print ("<A HREF=\"tictactoe.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&X=$j&Y=$i&CODE=$CODE\">");
			print DrawPiece($Board[$j][$i]);
			print ("</A>");
		}
		else print DrawPiece($Board[$j][$i]);
		print "</TD>";
	};
	print"<TD><IMG SRC=graphics/ticta-bord5.jpg></TD></TR>";
};
?>
<TR><TD><IMG SRC=graphics/ticta-bord6.jpg></TD><TD><IMG SRC=graphics/ticta-bord7.jpg></TD><TD><IMG SRC=graphics/ticta-bord7.jpg></TD><TD><IMG SRC=graphics/ticta-bord7.jpg></TD><TD><IMG SRC=graphics/ticta-bord8.jpg></TD></TR>
</TABLE>
<BR>
<? print ("<A HREF=\"welcome.php?USERNAME=$USERNAME&CODE=$CODE&CLOSE=1\" TARGET=LEFT>"); ?>
CLOSE GAME</A> - 
<? print ("<A HREF=\"tictactoe.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&RESET=1\">"); ?>
NEW GAME</A> - 
<? print ("<A HREF=\"tictactoe.php?USERNAME=$USERNAME&OPPONENT=$OPPONENT&CODE=$CODE&HELP=1\">"); ?>
HELP</A>
<BR></FONT>
OVERALL SCORE:  
<? print("$Player[1](X's) $PlayerScore[1] games; $Player[2](O's) $PlayerScore[2] games"); ?>
<BR>

</CENTER></BODY></HTML>
